// version 3.000
/**************************************************
 * dom-drag.js
 * 09.25.2001
 * www.youngpup.net
 **************************************************/
//
// mphMain is a global var for the current window  ap 14.10.2004
//
var Drag = {

	obj : null,

	init : function(o, oRoot, minX, maxX, minY, maxY, bSwapHorzRef, bSwapVertRef, fXMapper, fYMapper) {

		o.onmousedown	= Drag.start;

		o.hmode		= bSwapHorzRef ? false : true ;
		o.vmode		= bSwapVertRef ? false : true ;

		o.root = oRoot && oRoot != null ? oRoot : o ;

		if (o.hmode  && isNaN(parseInt(o.root.style.left  ))) o.root.style.left   = "0px";
		if (o.vmode  && isNaN(parseInt(o.root.style.top   ))) o.root.style.top    = "0px";
		if (!o.hmode && isNaN(parseInt(o.root.style.right ))) o.root.style.right  = "0px";
		if (!o.vmode && isNaN(parseInt(o.root.style.bottom))) o.root.style.bottom = "0px";

		o.minX	= typeof minX != 'undefined' ? minX : null;
		o.minY	= typeof minY != 'undefined' ? minY : null;
		o.maxX	= typeof maxX != 'undefined' ? maxX : null;
		o.maxY	= typeof maxY != 'undefined' ? maxY : null;

		o.xMapper = fXMapper ? fXMapper : null;
		o.yMapper = fYMapper ? fYMapper : null;

		o.root.onDragStart	= new Function();
		o.root.onDragEnd	= new Function();
		o.root.onDrag		= new Function();
	},

	start : function(e) {
		
		var o = Drag.obj = this;
		e = Drag.fixE(e);
		var y = parseInt(o.vmode ? o.root.style.top  : o.root.style.bottom);
		var x = parseInt(o.hmode ? o.root.style.left : o.root.style.right );
		o.root.onDragStart(x, y);

		o.lastMouseX	= e.clientX;
		o.lastMouseY	= e.clientY;

		if (o.hmode) {
			if (o.minX != null) o.minMouseX	= e.clientX - x + o.minX;
			if (o.maxX != null) o.maxMouseX	= o.minMouseX + o.maxX - o.minX;
		} else {
			if (o.minX != null) o.maxMouseX = -o.minX + e.clientX + x;
			if (o.maxX != null) o.minMouseX = -o.maxX + e.clientX + x;
		}

		if (o.vmode) {
			if (o.minY != null) o.minMouseY	= e.clientY - y + o.minY;
			if (o.maxY != null) o.maxMouseY	= o.minMouseY + o.maxY - o.minY;
		} else {
			if (o.minY != null) o.maxMouseY = -o.minY + e.clientY + y;
			if (o.maxY != null) o.minMouseY = -o.maxY + e.clientY + y;
		}

		mphMain.document.onmousemove = Drag.drag;
		mphMain.document.onmouseup = Drag.end;

		return false;
	},

	drag : function(e) {
		e = Drag.fixE(e);
		var o = Drag.obj;

		var ey	= e.clientY;
		var ex	= e.clientX;
		var y = parseInt(o.vmode ? o.root.style.top  : o.root.style.bottom);
		var x = parseInt(o.hmode ? o.root.style.left : o.root.style.right );
		var nx, ny;

		if (o.minX != null) ex = o.hmode ? Math.max(ex, o.minMouseX) : Math.min(ex, o.maxMouseX);
		if (o.maxX != null) ex = o.hmode ? Math.min(ex, o.maxMouseX) : Math.max(ex, o.minMouseX);
		if (o.minY != null) ey = o.vmode ? Math.max(ey, o.minMouseY) : Math.min(ey, o.maxMouseY);
		if (o.maxY != null) ey = o.vmode ? Math.min(ey, o.maxMouseY) : Math.max(ey, o.minMouseY);

		nx = x + ((ex - o.lastMouseX) * (o.hmode ? 1 : -1));
		ny = y + ((ey - o.lastMouseY) * (o.vmode ? 1 : -1));

		if (o.xMapper)		nx = o.xMapper(y)
		else if (o.yMapper)	ny = o.yMapper(x)

		Drag.obj.root.style[o.hmode ? "left" : "right"] = nx + "px";
		Drag.obj.root.style[o.vmode ? "top" : "bottom"] = ny + "px";
		Drag.obj.lastMouseX	= ex;
		Drag.obj.lastMouseY	= ey;

		Drag.obj.root.onDrag(nx, ny);
		return false;
	},

	end : function() {
		mphMain.document.onmousemove = null;
		mphMain.document.onmouseup   = null;
		Drag.obj.root.onDragEnd(	parseInt(Drag.obj.root.style[Drag.obj.hmode ? "left" : "right"]), 
						parseInt(Drag.obj.root.style[Drag.obj.vmode ? "top" : "bottom"]));
		Drag.obj = null;
	},

	fixE : function(e) {
		if (typeof e == 'undefined') e = mphMain.event;
		if (typeof e.layerX == 'undefined') e.layerX = e.offsetX;
		if (typeof e.layerY == 'undefined') e.layerY = e.offsetY;
		return e;
	}

};
/**************************************************************************/

/////////////////////////////////////////////////////////////////////////////////////////////////////////
// 1. Multiple Choice //////////////////////////////////////////////////////////////////////////////////////
var mcObj = {};

mcObj.question = function(radio,truefalse) {
	// add the Q icon to the panel
	mph.qToPanels();
	// Update question number in "footer"
	if (mphObj.isTest) mph.updateQuestionNum(mphObj.currPage);
	
	mcObj.obj = {};
	mcObj.obj.choices = [];
	mcObj.obj.numOptions = 0;
	mcObj.obj.clickIDs = [];
	mcObj.obj.answered = null;
	mcObj.obj.radio = radio  || false;
	mcObj.obj.tf = truefalse || false;
	mcObj.obj.order = [];
	mcObj.obj.pos = [];
	
	if (mcObj.obj.tf) mcObj.obj.radio = true;
	mphObj.currQtype = (mcObj.obj.tf?"tf":"mc");
	
	if (typeof mphPrefs.useMCToggleBtn == 'undefined') mphPrefs.useMCToggleBtn = true;
	mphPrefs.useMCToggleBtn ? mcObj.obj.btnPos = "left" : mcObj.obj.btnPos = "right";
	
	if (!mphObj.isTest && !mphPrefs.nextEnabled) mph.disableNext();
	
	if (mphObj.isTest && mphPrefs.assessTimeLimit) mph.timeLimit();
	
	if (typeof quest[mphObj.currPage] == 'undefined') {
		mcObj.obj.numOptions = 0;
	} else {
		if (typeof quest[mphObj.currPage] == "string")
			quest[mphObj.currPage] = mph.createArray(quest[mphObj.currPage],mphObj.currPage,"m");
		mcObj.obj.numOptions = quest[mphObj.currPage].length;
	}
	
	if (mcObj.obj.numOptions > 1) mcObj.obj.radio = false;
	
	// init LMS question tracking
	if (mphPrefs.LMS) {
		mcObj.obj.startTime = new Date().getTime();
		
		var a = mphObj.currPage;		// id
		var b = mphObj.currTopicNum;	// current topic
		// correct response
		var c = quest[mphObj.currPage].toString();
		c = c.replace(/false/g,"0").replace(/true/g,"1");
		var d = mphObj.currQtype;		// question type
		var e = mcObj.obj.startTime;	// start time in ms
		
		mphLMS.scormInteractionInit(a, b, c, d, e);
	}
	
	mcObj.obj.doneID = mphMain.document.getElementById("done");
	mcObj.obj.doneID.onclick = mcObj.feedback;
	mcObj.obj.doneID.onmouseover = function() { this.style.backgroundPosition = "0 -"+mphObj.btnDoneHeight+"px" };
	mcObj.obj.doneID.onmouseout =  function() { this.style.backgroundPosition = "0 0" };
	
	if (mphObj.isTest) mcObj.obj.doneID.style.visibility = (mphPrefs.assessDoneVisible)?"visible":"hidden";
		else mcObj.obj.doneID.style.visibility = (mphPrefs.doneVisible)?"visible":"hidden";
	
	// position items
	for (var i=0; i<mcObj.obj.numOptions; i++) {
		if ( !mphMain.document.getElementById("option"+i) ) {
			mcObj.obj.numOptions--;
			continue;
		}
		
		var tmpA = mph.getElementPositionAndSize("option"+i);
		var tmp = parseInt(tmpA[3],10);
		if (tmp>57) mphMain.document.getElementById("mc"+i).style.height = "57px";
		
		mcObj.obj.clickIDs[i] = mphMain.document.getElementById("option"+i);
		if (mcObj.obj.tf) {
			mcObj.obj.pos[i] = (i + (i==0?0.75:1.25)) * (40 + 20) + 10 + "px";
		} else {
			mcObj.obj.pos[i] = i * (40 + 20) + 10 + "px";
		}
		mcObj.obj.order[i] = i;
		mcObj.obj.choices[i] = false;
	}
	
	if (!mcObj.obj.tf && mphObj.isTest && mphPrefs.assessOptionsRandom) {
		if (typeof mphRandom[mphObj.currPage] == 'undefined') {
			mcObj.obj.order = mph.shuffleArray(mcObj.obj.order);
			mphRandom[mphObj.currPage] = mcObj.obj.order;
		} else {
			mcObj.obj.order = mphRandom[mphObj.currPage];
		}
	}
	for (var i=0; i<mcObj.obj.numOptions; i++) {
		var tmp = mcObj.obj.order[i];
		mcObj.obj.clickIDs[tmp].style.top = mcObj.obj.pos[i];
	}
	
	for (var i=0; i<mcObj.obj.numOptions; i++) {
		var oDiv = mphMain.document.getElementById("img"+mcObj.obj.order[i]);
		oDiv.style.backgroundImage = "url(scripts/pics/mc_"+i+".gif)";
		oDiv.style.backgroundPosition = "top "+mcObj.obj.btnPos;
		oDiv.title = "toggle button " + (i+1);
		mcObj.obj.clickIDs[i].onclick = mcObj.optionClicked;
		mcObj.obj.clickIDs[i].number = i;
	}
	
	if (mphObj.isTest && typeof mphAssessScore[mphObj.currPage]!='undefined' && mphAssessScore[mphObj.currPage]!=null) mcObj.rebuildQuestion();
		else mph.resultTally(mcObj.obj.answered);
};
mcObj.optionClicked = function() {
	var num = this.number, oDiv, nDiv = mphMain.document.getElementById("img"+num);
	if (mcObj.obj.radio) {
		for (var i=0; i<mcObj.obj.numOptions; i++) {
			oDiv = mphMain.document.getElementById("img"+i);
			oDiv.style.backgroundPosition = "top "+mcObj.obj.btnPos;
			mcObj.obj.choices[i] = false;
		}
		nDiv.style.backgroundPosition = "bottom "+mcObj.obj.btnPos;
		mcObj.obj.choices[num] = true;
	} else {
		if (mcObj.obj.choices[num]) {
			nDiv.style.backgroundPosition = "top "+mcObj.obj.btnPos;
			mcObj.obj.choices[num] = false;
		} else {
			nDiv.style.backgroundPosition = "bottom "+mcObj.obj.btnPos;
			mcObj.obj.choices[num] = true;
		}
	}

	// if no Done button then evaluate on attempt
	if (mphObj.isTest && !mphPrefs.assessDoneVisible) mcObj.feedback();
	if (!mphObj.isTest && !mphPrefs.doneVisible) mcObj.feedback();
};
mcObj.feedback = function() {
	if (mphObj.isTest && mphPrefs.assessMemory) mphMem[mphObj.currPage] = mcObj.obj.choices;
	
	// has the question been answered correctly?
	var f = quest[mphObj.currPage].toString();
	var d = mcObj.obj.choices.toString();
	if (mcObj.obj.numOptions != 0 && f == d) mcObj.obj.answered = true;
		else mcObj.obj.answered = false;
	
	// LMS tracking every question
	if (mphPrefs.LMS) {
		mcObj.obj.time = new Date();
		var a = mcObj.obj.startTime;		// start time
		var b = mcObj.obj.time.getTime();	// end time in ms
		var c = mcObj.obj.answered;			// result
		d = d.replace(/false/g,"0").replace(/true/g,"1");	// user response
		
		mphLMS.scormInteractionSet(a, b, c, d);
	}
	
	mph.resultTally(mcObj.obj.answered);
	
	mcObj.lockQuestion();
	if (mphObj.isTest) {
		if (mphPrefs.assessShowCorrect && !mcObj.obj.answered) mcObj.showCorrect();	
		if (!mphPrefs.assessShowCorrect && !mcObj.obj.answered) mph.feedback(mcObj.obj.answered);
	} else {
		if (mphPrefs.showCorrect && !mcObj.obj.answered) mcObj.showCorrect();	
		if (!mphPrefs.showCorrect && !mcObj.obj.answered) mph.feedback(mcObj.obj.answered);
	}
	
	if (mcObj.obj.answered) mph.feedback(mcObj.obj.answered);
};
mcObj.lockQuestion = function() {
	for (var i=0; i<mcObj.obj.numOptions; i++) {
		mcObj.obj.clickIDs[i].onclick = null;
		mcObj.obj.clickIDs[i].style.cursor = "default";
	}
	// hide the done button
	mcObj.obj.doneID.style.visibility = "hidden";
};
mcObj.resetQuestion =function() {
	for (var i=0; i<mcObj.obj.numOptions; i++) {
		mcObj.obj.clickIDs[i].onclick = mcObj.optionClicked;
		mcObj.obj.clickIDs[i].style.cursor = mphObj.mphCursor;
		mcObj.obj.choices[i] = false;
		oDiv = mphMain.document.getElementById("img"+i);
		oDiv.style.backgroundPosition = "top "+mcObj.obj.btnPos;
	}
	// show the done button
	if (mphObj.isTest) mcObj.obj.doneID.style.visibility = (mphPrefs.assessDoneVisible)?"visible":"hidden";
		else mcObj.obj.doneID.style.visibility = (mphPrefs.doneVisible)?"visible":"hidden";
};
mcObj.rebuildQuestion = function() {
	if (typeof mphMem[mphObj.currPage] != 'undefined') {
		if (mphPrefs.assessMemory) {
			for (var i=0; i<mphMem[mphObj.currPage].length; i++) {
				if (mphMem[mphObj.currPage][i]) {
					mcObj.obj.choices[i] = true;
					var oDiv = mphMain.document.getElementById("img"+i);
					oDiv.style.backgroundPosition = "bottom "+mcObj.obj.btnPos;
				}
			}
		} else {
			// is another attempt permitted
			mcObj.lockQuestion();
		}
	}
};
mcObj.showCorrect =function() {
	for (var i=0; i<mcObj.obj.numOptions; i++) {
		var oDiv = mphMain.document.getElementById("img"+i);
		if (quest[mphObj.currPage][i]) oDiv.style.backgroundPosition = "bottom "+mcObj.obj.btnPos;
			else oDiv.style.backgroundPosition = "top "+mcObj.obj.btnPos;
	}
	mphObj.timeouts.push(setTimeout("mph.feedback(mcObj.obj.answered)", 300) );
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////
// 2. Complete the Paragraph ///////////////////////////////////////////////////////////////////////////////
var cpObj = {};

cpObj.question = function() {
	// add the Q icon to the panel
	mph.qToPanels();
	// Update question number in "footer"
	if (mphObj.isTest) mph.updateQuestionNum(mphObj.currPage);
	
	mphObj.currQtype = "cp";
	
	cpObj.obj = {};
	cpObj.obj.numOptions = 0;
	cpObj.obj.drags = [];
	cpObj.obj.dragObj = null;
	cpObj.obj.targets = [];
	cpObj.obj.choices = [];
	cpObj.obj.tolerance = [30,15];
	cpObj.obj.dragIDs = [];
	cpObj.obj.dragsPos = [];
	cpObj.obj.targetIDs = [];
	cpObj.obj.targetsPos = [];
	cpObj.obj.numSlideSteps = 100;
	cpObj.obj.slideTimePerStep = 10;
	cpObj.obj.slideInterval = [];
	cpObj.obj.slideStartPos = [];
	cpObj.obj.counter = 0;
	// how much to pad out each side of the widest drag object
	cpObj.obj.increase = 20;
	cpObj.obj.answered = null;
	
	// get the ID of each object
	var tmpEl = false
	if (mphMain.document.getElementById("drag0")) {
		tmpEl = mphMain.document.getElementById("drag0");
		quest[mphObj.currPage] = [];
	}
	while (tmpEl) {
		var i = cpObj.obj.numOptions;
		quest[mphObj.currPage][i] = i;
		cpObj.obj.drags[i] = "drag" + i;
		cpObj.obj.targets[i] = "target" + i;
		cpObj.obj.choices[i] = "none";
		cpObj.obj.dragIDs[i] = mphMain.document.getElementById(cpObj.obj.drags[i]);
		cpObj.obj.targetIDs[i] = mphMain.document.getElementById(cpObj.obj.targets[i]);
		cpObj.obj.numOptions++;
		if (mphMain.document.getElementById("drag"+cpObj.obj.numOptions)) tmpEl = mphMain.document.getElementById("drag"+cpObj.obj.numOptions);
			else tmpEl = false;
	}
	
	// init LMS question tracking
	if (mphPrefs.LMS) {
		cpObj.obj.startTime = new Date().getTime();
		
		var a = mphObj.currPage;								// id
		var b = mphObj.currTopicNum;						// current topic
		// correct response
		var c = quest[mphObj.currPage].toString();
		var d = mphObj.currQtype;								// question type
		var e = cpObj.obj.startTime;						// start time in ms
		
		mphLMS.scormInteractionInit(a, b, c, d, e);
	}
	
	if (cpObj.obj.numOptions != 0) cpObj.start();
	
	if (!mphObj.isTest && !mphPrefs.nextEnabled) mph.disableNext();
	
	if (mphObj.isTest && mphPrefs.assessTimeLimit) mph.timeLimit();
	
	cpObj.obj.doneID = mphMain.document.getElementById("done");
	cpObj.obj.doneID.onclick = cpObj.feedback;
	cpObj.obj.doneID.onmouseover = function() { this.style.backgroundPosition = "0 -"+mphObj.btnDoneHeight+"px" };
	cpObj.obj.doneID.onmouseout =  function() { this.style.backgroundPosition = "0 0" };
	
	if (mphObj.isTest) cpObj.obj.doneID.style.visibility = (mphPrefs.assessDoneVisible)?"visible":"hidden";
		else cpObj.obj.doneID.style.visibility = (mphPrefs.doneVisible)?"visible":"hidden";
		
	for (var i=0; i<cpObj.obj.numOptions; i++) {
		// get the start position of each draggable object
		cpObj.obj.dragsPos[i] = mph.getElementPositionAndSize(cpObj.obj.drags[i]);
		// get the position of each drop target
		cpObj.obj.targetsPos[i] = mph.getElementPositionAndSize(cpObj.obj.targets[i]);
		// correction for border width
		cpObj.obj.targetsPos[i][0] = cpObj.obj.targetsPos[i][0] + 1;
		cpObj.obj.targetsPos[i][1] = cpObj.obj.targetsPos[i][1] + 1;
		
		// set the drag confines
		var maxX = 1008 - cpObj.obj.dragsPos[i][2] - 1;
		var maxY = 560 - cpObj.obj.dragsPos[i][3] * 2;
		cpObj.setDrag(i,maxX,maxY);
	}
	// has the question already been done
	if (mphObj.isTest && typeof mphAssessScore[mphObj.currPage]!='undefined' && mphAssessScore[mphObj.currPage]!=null) cpObj.rebuildQuestion();
		else mph.resultTally(cpObj.obj.answered);
};
// position and size drags and targets
cpObj.start = function() {
	var widest = 0;
	var w = [];
	
	for (var i=0; i<cpObj.obj.numOptions; i++) {
		w[i] = cpObj.obj.dragIDs[i].offsetWidth;
		if (w[i] > widest) widest = w[i];
	}

	widest += cpObj.obj.increase;
	highest = cpObj.obj.dragIDs[0].offsetHeight;
	
	for (var i = 0; i<cpObj.obj.numOptions; i++) {
		var pad = parseInt((widest - w[i])/2,10);
		var leftover = ((widest - w[i])%2);
		cpObj.obj.dragIDs[i].style.paddingLeft = pad+leftover+"px";
		cpObj.obj.dragIDs[i].style.paddingRight = pad+"px";
		
		pad = widest - cpObj.obj.targetIDs[i].offsetWidth;
		cpObj.obj.targetIDs[i].style.paddingLeft = pad+"px"
		cpObj.obj.targetIDs[i].style.marginRight = "2px";
		
		if (!mphObj.isIE) {
			if (cpObj.obj.dragIDs[i].offsetHeight > cpObj.obj.targetIDs[i].offsetHeight)
				cpObj.obj.dragIDs[i].style.paddingBottom = "0px";
		}
	}
	// Position drags
	if (typeof mphRandom[mphObj.currPage] == 'undefined') {
		var tmpArray = [];
		for (var i=0; i<cpObj.obj.numOptions; i++) tmpArray[i] = i;
		var randomPos = mph.shuffleArray(tmpArray);
		mphRandom[mphObj.currPage] = randomPos;
	}
	
	if (cpObj.obj.numOptions>5) {
		var lefttmp = (930 - widest * 5) / 5;
		var toptmp = (82 - highest * 2) / 3;
		for (var i = 0; i<cpObj.obj.numOptions; i++) {
			var j = mphRandom[mphObj.currPage][i];
			if (i>4) {
				cpObj.obj.dragIDs[j].style.left = 39 + (lefttmp/2) + (i-5) * (lefttmp + widest) + "px";
				cpObj.obj.dragIDs[j].style.top = 120 + toptmp * 2 + highest + "px";
			} else {
				cpObj.obj.dragIDs[j].style.left = 39 + (lefttmp/2) + i * (lefttmp + widest) + "px";
				cpObj.obj.dragIDs[j].style.top = 120 + toptmp + "px";
			}
		}
		//
	} else {
		var lefttmp = (930 - widest * cpObj.obj.numOptions) / cpObj.obj.numOptions;
		var toptmp = (82 - highest) / 2;
		for (var i = 0; i<cpObj.obj.numOptions; i++) {
			var j = mphRandom[mphObj.currPage][i];
			cpObj.obj.dragIDs[j].style.left = 39 + (lefttmp/2) + i * (lefttmp + widest) + "px";
			cpObj.obj.dragIDs[j].style.top = 120 + toptmp + "px";
		}
	}
};
// setup dragging of objects
cpObj.setDrag = function(i,maxX,maxY) {
	cpObj.obj.dragObj = cpObj.obj.dragIDs[i];
	Drag.init(cpObj.obj.dragObj,null,1,maxX,1,maxY);
	
	cpObj.obj.dragObj.onDragEnd = function(x, y) {
		cpObj.obj.dragObj = cpObj.obj.dragIDs[this.number];
		var matchFound = false;
		for (var k=0; k<cpObj.obj.numOptions; k++) {
			if (cpObj.obj.choices[k]=="none" || cpObj.obj.choices[k]==this.number) {
				if ( (Math.abs(x-cpObj.obj.targetsPos[k][0])<=cpObj.obj.tolerance[0])  && (Math.abs(y-cpObj.obj.targetsPos[k][1])<=cpObj.obj.tolerance[1]) ) {
					cpObj.obj.dragObj.style.left = cpObj.obj.targetsPos[k][0]+"px";
					cpObj.obj.dragObj.style.top = cpObj.obj.targetsPos[k][1]+"px";
					for (j=0; j<cpObj.obj.numOptions; j++) { if (cpObj.obj.choices[j]==this.number) { cpObj.obj.choices[j] = "none"; } }
					cpObj.obj.choices[k] = this.number;
					matchFound = true;
					break;
				}	
			}
		}
		if (matchFound==false) {
			cpObj.obj.dragObj.style.left = cpObj.obj.dragsPos[this.number][0]+"px";
			cpObj.obj.dragObj.style.top = cpObj.obj.dragsPos[this.number][1]+"px";
			for (j=0; j<cpObj.obj.numOptions; j++) { if (cpObj.obj.choices[j]==this.number) { cpObj.obj.choices[j] = "none"; } }
		}
	
	if (mphObj.isTest && !mphPrefs.assessDoneVisible && (cpObj.obj.choices.toString()).indexOf("none")==-1 ) cpObj.feedback();
	if (!mphObj.isTest && !mphPrefs.doneVisible && (cpObj.obj.choices.toString()).indexOf("none")==-1 ) cpObj.feedback();
	}
	cpObj.obj.dragObj.number = i;
};
cpObj.feedback = function() {
	if (mphObj.isTest && mphPrefs.assessMemory) mphMem[mphObj.currPage] = cpObj.obj.choices;
	
	// get gradient between drop and target (TAN)
	for (var i=0; i<cpObj.obj.numOptions; i++) {
		tmp = mph.getElementPositionAndSize(cpObj.obj.drags[i]);
		cpObj.obj.slideStartPos[i] = [tmp[0],tmp[1]];
		cpObj.obj.slideInterval[i] = [];
		cpObj.obj.slideInterval[i][0] = (cpObj.obj.targetsPos[i][0] - tmp[0]) / cpObj.obj.numSlideSteps;
		cpObj.obj.slideInterval[i][1] = (cpObj.obj.targetsPos[i][1] - tmp[1]) / cpObj.obj.numSlideSteps;
	}
	
	// has the question been answered correctly?
	var f = quest[mphObj.currPage].toString();
	var d = cpObj.obj.choices.toString();
	if (cpObj.obj.numOptions != 0 && f == d) cpObj.obj.answered = true;
		else cpObj.obj.answered = false;
	
	// LMS tracking every question
	if (mphPrefs.LMS) {
		cpObj.obj.time = new Date();
		var a = cpObj.obj.startTime;						// start time
		var b = cpObj.obj.time.getTime();				// end time in ms
		var c = cpObj.obj.answered;							// result
		// user response
		d = d.replace(/none/g,"a");
		
		mphLMS.scormInteractionSet(a, b, c, d);
	}
	
	mph.resultTally(cpObj.obj.answered);
	
	cpObj.lockQuestion()
	
	if (mphObj.isTest) {
		if (mphPrefs.assessShowCorrect && !cpObj.obj.answered) cpObj.showCorrect();	
		if (!mphPrefs.assessShowCorrect && !cpObj.obj.answered) mph.feedback(cpObj.obj.answered);
	} else {
		if (mphPrefs.showCorrect && !cpObj.obj.answered) cpObj.showCorrect();	
		if (!mphPrefs.showCorrect && !cpObj.obj.answered) mph.feedback(cpObj.obj.answered);
	}
	
	if (cpObj.obj.answered) mph.feedback(cpObj.obj.answered);
};
cpObj.lockQuestion = function() {
	for (var i=0; i<cpObj.obj.numOptions; i++) {
		cpObj.obj.dragIDs[i].onmousedown = null;
		cpObj.obj.dragIDs[i].onmouseup = null;
		cpObj.obj.dragIDs[i].style.cursor = "default";
	}
	// hide the done button
	cpObj.obj.doneID.style.visibility = "hidden";
};
cpObj.resetQuestion = function() {
	for (var i=0; i<cpObj.obj.numOptions; i++) {
		cpObj.obj.choices[i] = "none";
		
		cpObj.setDrag(i);
		cpObj.obj.dragObj.style.cursor = "move";
		cpObj.obj.dragObj.style.left = cpObj.obj.dragsPos[i][0]+"px";
		cpObj.obj.dragObj.style.top = cpObj.obj.dragsPos[i][1]+"px";
	}
	// show the done button
	if (mphObj.isTest) cpObj.obj.doneID.style.visibility = (mphPrefs.assessDoneVisible)?"visible":"hidden";
		else cpObj.obj.doneID.style.visibility = (mphPrefs.doneVisible)?"visible":"hidden";
};
cpObj.rebuildQuestion = function() {
	if (typeof mphMem[mphObj.currPage] != 'undefined') {
		if (mphPrefs.assessMemory) {
			for (var i=0; i<mphMem[mphObj.currPage].length; i++) {
				var num = mphMem[mphObj.currPage][i];
				if ( isNaN(num) ) continue;
				cpObj.obj.choices[i] = num;
				
				cpObj.obj.dragIDs[num].style.left = cpObj.obj.targetsPos[i][0]+"px";
				cpObj.obj.dragIDs[num].style.top = cpObj.obj.targetsPos[i][1]+"px";
			}
		} else {
			// is another attempt permitted
			cpObj.lockQuestion();
		}
	}
};
cpObj.showCorrect = function() {
	for (var i=0; i<cpObj.obj.numOptions; i++) {
		cpObj.obj.slideStartPos[i][0] += cpObj.obj.slideInterval[i][0]
		cpObj.obj.dragIDs[i].style.left = cpObj.obj.slideStartPos[i][0] + "px";
		cpObj.obj.slideStartPos[i][1] += cpObj.obj.slideInterval[i][1]
		cpObj.obj.dragIDs[i].style.top = cpObj.obj.slideStartPos[i][1] + "px";
	}
	
	cpObj.obj.counter++;
	if (cpObj.obj.counter==cpObj.obj.numSlideSteps) {
		// force final positions in case of round off errors
		for (var i=0; i<cpObj.obj.numOptions; i++) {
			cpObj.obj.dragIDs[i].style.left = cpObj.obj.targetsPos[i][0] + "px";
			cpObj.obj.dragIDs[i].style.top = cpObj.obj.targetsPos[i][1] + "px";
		}
		mphObj.timeouts.push(setTimeout("mph.feedback(cpObj.obj.answered)", 300) );
	} else {
			// loop to move the pieces closer to their correct targets
		mphObj.timeouts.push(setTimeout('cpObj.showCorrect()', cpObj.obj.slideTimePerStep));
	}
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////
// 3. Fill in the Blanks //////////////////////////////////////////////////////////////////////////////////////
var fbObj = {};

fbObj.NewQuestion = function() {
	// Update question number in "footer"
	if (mphObj.isTest) mph.updateQuestionNum(mphObj.currPage);
	
	this.doneID = mphMain.document.getElementById("done");
	this.numOptions = 0;
	this.optionIDs = [];
	this.subStr = [];
	this.maxWord = 0;
	this.answered = null;
};
fbObj.NewQuestion.prototype.maxWordLength = function () {
	var maxWord = 0;
	var tmp = quest[mphObj.currPage].length;
	for (var i=0; i<tmp; i++) {
		this.subStr[i] = quest[mphObj.currPage][i].toLowerCase();
		if( this.subStr[i].indexOf(";")!=-1) {
			this.subStr[i] = quest[mphObj.currPage][i].split(";");
			for (var j=0; j<this.subStr[i].length; j++) {
				if( this.subStr[i][j].length > maxWord ) maxWord = this.subStr[i][j].length;
			}
		} else {
			if( this.subStr[i].length > maxWord ) maxWord = this.subStr[i].length;
		}
	}
	return maxWord;
};
fbObj.removeNameAtt = function() {
	var allNames = mphMain.document.getElementsByTagName("input");
	var len = allNames.length;
	for (var i = 0; i<len; i++) allNames[i].removeAttribute("name");
};
fbObj.question = function() {
	// remove name attribute - IE only
	if (mphObj.isIE) fbObj.removeNameAtt();
	// add the Q icon to the panel
	mph.qToPanels();
	mphObj.currQtype = "fb";
	fbObj.obj = new fbObj.NewQuestion();
	
	if (typeof quest[mphObj.currPage] == 'undefined') {
		fbObj.obj.numOptions = 0;
	} else {
		if (typeof quest[mphObj.currPage] == "string")
			quest[mphObj.currPage] = mph.createArray(quest[mphObj.currPage],mphObj.currPage,"f");
		
		fbObj.obj.numOptions = quest[mphObj.currPage].length;
		fbObj.obj.maxWord = fbObj.obj.maxWordLength();
	}
	
		// init LMS question tracking
	if (mphPrefs.LMS) {
		fbObj.obj.startTime = new Date().getTime();
		
		var a = mphObj.currPage;								// id
		var b = mphObj.currTopicNum;						// current topic
		if (fbObj.obj.numOptions == 0) var c = " ";
			else var c = quest[mphObj.currPage].join(" ");			// correct response
		var d = mphObj.currQtype;								// question type
		var e = fbObj.obj.startTime;						// start time inms
		
		mphLMS.scormInteractionInit(a, b, c, d, e);
	}	
	
	if (!mphObj.isTest && !mphPrefs.nextEnabled) mph.disableNext();
	
	if (mphObj.isTest && mphPrefs.assessTimeLimit) mph.timeLimit();
	
	fbObj.obj.doneID.onclick = fbObj.feedback;
	fbObj.obj.doneID.onmouseover = function() { this.style.backgroundPosition = "0 -"+mphObj.btnDoneHeight+"px" };
	fbObj.obj.doneID.onmouseout =  function() { this.style.backgroundPosition = "0 0" };
	
	if (mphObj.isTest) fbObj.obj.doneID.style.visibility = (mphPrefs.assessDoneVisible)?"visible":"hidden";
		else fbObj.obj.doneID.style.visibility = (mphPrefs.doneVisible)?"visible":"hidden";
	
	for (var i=0; i<fbObj.obj.numOptions; i++) {
		fbObj.obj.optionIDs[i] = mphMain.document.getElementById("option"+i);
		fbObj.obj.optionIDs[i].maxLength = fbObj.obj.maxWord + 4;
		fbObj.obj.optionIDs[i].size = fbObj.obj.maxWord +8;
	}
	
	if (mphObj.isTest && typeof mphAssessScore[mphObj.currPage]!='undefined' && mphAssessScore[mphObj.currPage]!=null) fbObj.rebuildQuestion();
		else mph.resultTally(fbObj.obj.answered);
};
fbObj.feedback = function() {
	if (mphObj.isTest && mphPrefs.assessMemory) mphMem[mphObj.currPage] = [];
	var numCorrect = 0;
	var currValue;
	var g = []
	
	for (var i=0; i<fbObj.obj.numOptions; i++) {
		fbObj.obj.optionIDs[i].readOnly = true;
		currValue = fbObj.obj.optionIDs[i].value
		if (mphObj.isTest && mphPrefs.assessMemory) mphMem[mphObj.currPage][i] = currValue;
		currValue = currValue.toLowerCase();
		g.push(currValue);
		if( typeof(fbObj.obj.subStr[i])=="string" ) {
			if (currValue==fbObj.obj.subStr[i]) numCorrect++;
		} else {
			for (var j=0; j<fbObj.obj.subStr[i].length; j++) {
				if (currValue==fbObj.obj.subStr[i][j]) numCorrect++; 
			}
		}
	}
	
	// has the question been answered correctly?
	if (fbObj.obj.numOptions != 0 && numCorrect==fbObj.obj.numOptions) fbObj.obj.answered = true;
		else fbObj.obj.answered = false;
	
	// LMS tracking every question
	if (mphPrefs.LMS) {
		fbObj.obj.time = new Date();
		var a = fbObj.obj.startTime;						// start time
		var b = fbObj.obj.time.getTime();				// end time in ms
		var c = fbObj.obj.answered;							// result
		var d = g.join(" ");										// user response
		
		mphLMS.scormInteractionSet(a, b, c, d);
	}
	
	mph.resultTally(fbObj.obj.answered);
	
	fbObj.lockQuestion();
	
	if (mphObj.isTest) {
		if (mphPrefs.assessShowCorrect && !fbObj.obj.answered) fbObj.showCorrect();	
		if (!mphPrefs.assessShowCorrect && !fbObj.obj.answered) mph.feedback(fbObj.obj.answered);
	} else {
		if (mphPrefs.showCorrect && !fbObj.obj.answered) fbObj.showCorrect();	
		if (!mphPrefs.showCorrect && !fbObj.obj.answered) mph.feedback(fbObj.obj.answered);
	}
	
	if (fbObj.obj.answered) mph.feedback(fbObj.obj.answered);
};
fbObj.lockQuestion = function() {
	for (var i=0; i<fbObj.obj.numOptions; i++) fbObj.obj.optionIDs[i].readOnly = true;
	// hide the done button
	fbObj.obj.doneID.style.visibility = "hidden";	
};
fbObj.resetQuestion = function() {
	for (var i=0; i<fbObj.obj.numOptions; i++) {
		fbObj.obj.optionIDs[i].readOnly = false;
		fbObj.obj.optionIDs[i].value = "";
	}
	// show the done button
	if (mphObj.isTest) fbObj.obj.doneID.style.visibility = (mphPrefs.assessDoneVisible)?"visible":"hidden";
		else fbObj.obj.doneID.style.visibility = (mphPrefs.doneVisible)?"visible":"hidden";
};
fbObj.rebuildQuestion = function() {
	if (typeof mphMem[mphObj.currPage] != 'undefined') {
		if (mphPrefs.assessMemory) {
			for (var i=0; i<mphMem[mphObj.currPage].length; i++) {
				fbObj.obj.optionIDs[i].value = mphMem[mphObj.currPage][i];
			}
		} else {
			// is another attempt permitted
			fbObj.lockQuestion();
		}
	}
};
fbObj.showCorrect = function() {
	for (var i=0; i<fbObj.obj.numOptions; i++) {
		if( typeof(fbObj.obj.subStr[i])=="string" ) {
			fbObj.obj.optionIDs[i].value = quest[mphObj.currPage][i];
		} else {
			var tmp = quest[mphObj.currPage][i].split(";");
			fbObj.obj.optionIDs[i].value = tmp[0];
		}
	}
	
	mphObj.timeouts.push(setTimeout("mph.feedback(fbObj.obj.answered)", 300) );
};

//////////////////////////////////////////////////////////////////////////////////////////////////
// 4. Match the Pairs ///////////////////////////////////////////////////////////////////////////////
var mpObj = {};

mpObj.question = function(zoom) {
	// add the Q icon to the panel
	mph.qToPanels();
	// Update question number in "footer"
	if (mphObj.isTest) mph.updateQuestionNum(mphObj.currPage);
	
	mphObj.currQtype 	= "mp";
	mpObj.obj 			= {};
	mpObj.obj.zoom		= zoom || false;
	if (mpObj.obj.zoom) {
		mpObj.obj.lowerPanel = mphMain.document.getElementById("lowerpanel");
		mpObj.zoom();
	}
	
	mpObj.obj.numOptions = 0;
	mpObj.obj.choices 	= [];
	mpObj.obj.selOpt 	= false;
	mpObj.obj.currOpt 	= null;
	mpObj.obj.currTag 	= null;
	mpObj.obj.jg 		= [];
	mpObj.obj.startPos 	= [];
	mpObj.obj.endPos 	= [];
	mpObj.obj.optionIDs = [];
	mpObj.obj.targetIDs = [];
	mpObj.obj.oDiv 		= [];
	mpObj.obj.doneID 	= 0;
	mpObj.obj.loop 		= 0;
	mpObj.obj.answered 	= null;
	mpObj.obj.mpFdbk 	= false;
	
	if (mphObj.isIE && !mphMain.document.namespaces["v"]) {
		// create xmlns
		mphMain.document.namespaces.add("v","urn:schemas-microsoft-com:vml");
		// setup css
		var ss = mphMain.document.createStyleSheet();
		ss.cssText = "v\\:*{behavior:url(#default#VML)}";
	}
	
	if (!mphObj.isTest && !mphPrefs.nextEnabled) mph.disableNext();
	
	if (mphObj.isTest && mphPrefs.assessTimeLimit) mph.timeLimit();
	
	mpObj.obj.doneID 				= mphMain.document.getElementById("done");
	mpObj.obj.doneID.onclick 		= mpObj.feedback;
	mpObj.obj.doneID.onmouseover 	= function() { this.style.backgroundPosition = "0 -"+mphObj.btnDoneHeight+"px" };
	mpObj.obj.doneID.onmouseout 	=  function() { this.style.backgroundPosition = "0 0" };
	
	if (mphObj.isTest) mpObj.obj.doneID.style.visibility = (mphPrefs.assessDoneVisible)?"visible":"hidden";
		else mpObj.obj.doneID.style.visibility = (mphPrefs.doneVisible)?"visible":"hidden";
	
	// get the ID of each object
	var tmpEl = false;
	if (tmpEl = mphMain.document.getElementById("option0")) {
		quest[mphObj.currPage] = [];
	}
	while (tmpEl) {
		var i = mpObj.obj.numOptions;
		quest[mphObj.currPage][i] = i;
		mpObj.obj.optionIDs[i] = mphMain.document.getElementById("option" + i);
		mpObj.obj.targetIDs[i] = mphMain.document.getElementById("target" + i);
		mpObj.obj.numOptions++;
		if (mphMain.document.getElementById("option"+mpObj.obj.numOptions)) tmpEl = mphMain.document.getElementById("option"+mpObj.obj.numOptions);
			else tmpEl = false;
	}
		
	// init LMS question tracking
	if (mphPrefs.LMS) {
		mpObj.obj.startTime = new Date().getTime();
		
		var a = mphObj.currPage;		// id
		var b = mphObj.currTopicNum;	// current topic
		// correct response
		
		var c = []
		for (var i = 0; i < quest[mphObj.currPage].length; i++) {
			c.push((quest[mphObj.currPage][i]+1)+"."+(quest[mphObj.currPage][i]+1))
		}
		c = c.toString();
		var d = mphObj.currQtype;		// question type
		var e = mpObj.obj.startTime;	// start time inms
		
		mphLMS.scormInteractionInit(a, b, c, d, e);
	}
	
	if (mpObj.obj.numOptions != 0) mpObj.start();
	
	if (mphObj.isTest && typeof mphAssessScore[mphObj.currPage]!='undefined' && mphAssessScore[mphObj.currPage]!=null) mpObj.rebuildQuestion();
		else mph.resultTally(mpObj.obj.answered);
};
mpObj.zoom = function(){
	mpObj.obj.zoomID = mphMain.document.getElementById("mpZoom");
	
	var preload = [];
	var imgs = mpObj.obj.lowerPanel.getElementsByTagName("img");
	for (var i = 0, num = imgs.length; i < num; i++) {
		if (imgs[i].src.indexOf("scripts/pics/x.gif") != -1) continue;
		mph.addEvent(imgs[i], "mouseover", mpObj.displayLargeImg);
		mph.addEvent(imgs[i], "mouseout", mpObj.clearLargeImg);
		preload[i] = new Image();
		preload[i].src = imgs[i].src.replace(".png","large.png");
	}
};
mpObj.displayLargeImg = function(){
	var myi = mphMain.document.createElement("img");
	myi.style.display = "inline";
	myi.style.width = "186px";
	myi.style.height = "186px";
	myi.src = this.src.replace(".png","large.png");
	mpObj.obj.zoomID.appendChild(myi);
	mpObj.obj.zoomID.style.visibility = "visible";
};
mpObj.clearLargeImg = function(){
	mpObj.obj.zoomID.style.visibility = "hidden";
	mpObj.obj.zoomID.removeChild(mpObj.obj.zoomID.lastChild);
};
mpObj.start = function() {
	//get objects
	for (var i=0; i<mpObj.obj.numOptions; i++) {
		mpObj.obj.optionIDs[i] = mphMain.document.getElementById("option"+i);
		mpObj.obj.targetIDs[i] = mphMain.document.getElementById("target"+i);
	}
	
	if (typeof mphRandom[mphObj.currPage] == 'undefined') {
		var tmpArray = [];
		for (var i=0; i<mpObj.obj.numOptions; i++) tmpArray[i] = mpObj.obj.optionIDs[i].style.top;
		var randomPos = mph.shuffleArray(tmpArray);
		mphRandom[mphObj.currPage] = randomPos;
	}
	
	for( var i=0; i<mpObj.obj.numOptions; i++ ) {
		// position the target
		mpObj.obj.targetIDs[i].style.top = mphRandom[mphObj.currPage][i];
		
		mpObj.obj.choices[i] = "none";
		// the objects on the left (to be clicked first)
		var sz = mph.getElementPositionAndSize("option"+i); // offsetLeft, offsetTop, offsetWidth, offsetHeight, offsetLeftCentre, offsetTopCentre
		mpObj.obj.startPos[i] = [];
		mpObj.obj.startPos[i][0] = sz[0] + sz[2];
		mpObj.obj.startPos[i][1] = sz[5];
		mpObj.obj.optionIDs[i].style.cursor = mphObj.mphCursor;
		mpObj.obj.optionIDs[i].onclick = mpObj.drawLine;
		mpObj.obj.optionIDs[i].number = i;
		
		// the objects on the right (to be clicked second)
		sz = mph.getElementPositionAndSize("target"+i);
		mpObj.obj.endPos[i] = [];
		mpObj.obj.endPos[i][0] = sz[0];
		mpObj.obj.endPos[i][1] = sz[5];
		mpObj.obj.targetIDs[i].style.cursor = mphObj.mphCursor;
		mpObj.obj.targetIDs[i].onclick = mpObj.drawLine;
		mpObj.obj.targetIDs[i].number = i;
		
		if (!mphObj.isIE) {
			// create DIVs for graphics library to use
			mpObj.obj.oDiv[i] = mphMain.document.createElement("div");
			mpObj.obj.oDiv[i].setAttribute("id", "canvas"+i);
			mpObj.obj.oDiv[i].style.position = "absolute";
			mpObj.obj.oDiv[i].style.left = "0px";
			mpObj.obj.oDiv[i].style.top = "0px";
			mpObj.obj.oDiv[i].style.width = "100px";
			mpObj.obj.oDiv[i].style.height = "100px";
			mpObj.obj.oDiv[i].number = i
			mphMain.document.body.appendChild(mpObj.obj.oDiv[i]);
		}
	}
};
mpObj.restart = function() {
	for(var i=0; i<mpObj.obj.numOptions; i++ ) {
		mpObj.obj.choices[i] = "none";
		mpObj.obj.optionIDs[i].style.cursor = mphObj.mphCursor;
		mpObj.obj.optionIDs[i].onclick = mpObj.drawLine;
		mpObj.obj.optionIDs[i].number = i;

		mpObj.obj.targetIDs[i].style.cursor = mphObj.mphCursor;
		mpObj.obj.targetIDs[i].onclick = mpObj.drawLine;
		mpObj.obj.targetIDs[i].number = i;
	}
	if (mpObj.obj.zoom) mpObj.zoom();
};
mpObj.feedback = function() {
	if (mphObj.isTest && mphPrefs.assessMemory) mphMem[mphObj.currPage] = mpObj.obj.choices;
	
	mpObj.obj.mpFdbk = true;
	// has the question been answered correctly?
	var f = quest[mphObj.currPage].toString();
	var g = mpObj.obj.choices.toString();
	if (mpObj.obj.numOptions != 0 && f == g) mpObj.obj.answered = true;
		else mpObj.obj.answered = false;
	
	// LMS tracking every question
	if (mphPrefs.LMS) {
		mpObj.obj.time = new Date();
		var a = mpObj.obj.startTime;		// start time
		var b = mpObj.obj.time.getTime();	// end time in ms
		var c = mpObj.obj.answered;		// result
		// user response
		var d = [], tmp;
		for (i = 0; i < quest[mphObj.currPage].length; i++) {
			tmp = (mpObj.obj.choices[i] == "none" ? "a" : mpObj.obj.choices[i]+1 );
			d.push((quest[mphObj.currPage][i]+1)+"."+tmp);
		}
		d = d.toString();
		
		mphLMS.scormInteractionSet(a, b, c, d);
	}
	
	mph.resultTally(mpObj.obj.answered);
	
	mpObj.lockQuestion();
	
	if (mphObj.isTest) {
		if (mphPrefs.assessShowCorrect && !mpObj.obj.answered) mpObj.showCorrect();	
		if (!mphPrefs.assessShowCorrect && !mpObj.obj.answered) mph.feedback(mpObj.obj.answered);
	} else {
		if (mphPrefs.showCorrect && !mpObj.obj.answered) mpObj.showCorrect();	
		if (!mphPrefs.showCorrect && !mpObj.obj.answered) mph.feedback(mpObj.obj.answered);
	}
	
	if (mpObj.obj.answered) mph.feedback(mpObj.obj.answered);
};
mpObj.lockQuestion = function() {
	for( var i=0; i<mpObj.obj.numOptions; i++ ) {
		mpObj.obj.optionIDs[i].onclick = null;
		mpObj.obj.targetIDs[i].onclick = null;
		mpObj.obj.optionIDs[i].style.cursor = "default";
		mpObj.obj.targetIDs[i].style.cursor = "default";
	}
	
	if (mpObj.obj.zoom) {
		var imgs = mpObj.obj.lowerPanel.getElementsByTagName("img");
		for (var i = 0, num = imgs.length; i < num; i++) {
			if (imgs[i].src.indexOf("scripts/pics/x.gif") != -1) continue;
			mph.removeEvent(imgs[i], "mouseover", mpObj.displayLargeImg);
			mph.removeEvent(imgs[i], "mouseout", mpObj.clearLargeImg);
		}
	}
	// hide the done button
	mpObj.obj.doneID.style.visibility = "hidden";
};
mpObj.resetQuestion = function() {
	for (var i=0; i<mpObj.obj.numOptions; i++ ) mpObj.removeLine(i);
	
	mpObj.restart();
	
	// show the done button
	if (mphObj.isTest) mpObj.obj.doneID.style.visibility = (mphPrefs.assessDoneVisible)?"visible":"hidden";
		else mpObj.obj.doneID.style.visibility = (mphPrefs.doneVisible)?"visible":"hidden";
}

mpObj.rebuildQuestion = function() {
	if (typeof mphMem[mphObj.currPage] != 'undefined') {
		if (mphPrefs.assessMemory) {
			// draw the lines
			var n = 0;
			for (var i=0; i<mpObj.obj.numOptions; i++ ) {
				if (mphMem[mphObj.currPage][i]!="none") {
					n = mphMem[mphObj.currPage][i];
					mpObj.obj.choices[i] = n;
					mpObj.drawNewLine(i, n, mpObj.obj.startPos[i][0]-3,mpObj.obj.startPos[i][1],mpObj.obj.endPos[n][0],mpObj.obj.endPos[n][1]);
				}
			}
		} else {
			// is another attempt permitted
			mpObj.lockQuestion();
		}
	}
};
mpObj.drawLine = function() {
	if (this.id.indexOf("option")!=-1) {
		mpObj.obj.selOpt = true;
		mpObj.obj.currOpt = this.number;
		return;
	} else {
		// a left hand option must first be selected
		if (mpObj.obj.selOpt==false) return;
	}
	
	var m = mpObj.obj.currOpt // right hand selection
	var n = this.number;  // left hand selection
	
	// remove any existing line
	mpObj.removeLine(m);
	
	// draw a new line
	mpObj.drawNewLine(m, n, mpObj.obj.startPos[m][0]-3,mpObj.obj.startPos[m][1],mpObj.obj.endPos[n][0],mpObj.obj.endPos[n][1]);
	
	if (mphObj.isTest &&  !mpObj.obj.mpFdbk && !mphPrefs.assessDoneVisible && (mpObj.obj.choices.toString()).indexOf("none")==-1 ) {
		mphObj.timeouts.push(setTimeout("mpObj.feedback()", 600) );
	}
	if (!mphObj.isTest &&  !mpObj.obj.mpFdbk && !mphPrefs.doneVisible && (mpObj.obj.choices.toString()).indexOf("none")==-1 ) {
		mphObj.timeouts.push(setTimeout("mpObj.feedback()", 600) );
	}
};
mpObj.showCorrect = function() {
	// we're looping through this function so do the next bit once only
	if (mpObj.obj.loop==0) {
		for (var i=0; i<mpObj.obj.numOptions; i++ ) {
			if (mpObj.obj.choices[i]!="none") mpObj.removeLine(i);
		}
	}
	// draw a new line
	if (mpObj.obj.numOptions > 0) {
		var m = mpObj.obj.loop;
		var n = quest[mphObj.currPage][m];
		mpObj.drawNewLine(m, n, mpObj.obj.startPos[m][0]-3,mpObj.obj.startPos[m][1],mpObj.obj.endPos[n][0],mpObj.obj.endPos[n][1]);
	}
	mpObj.obj.loop++;
	if (mpObj.obj.loop>=mpObj.obj.numOptions) mphObj.timeouts.push(setTimeout("mph.feedback(mpObj.obj.answered)", 300) );
		else mphObj.timeouts.push(setTimeout("mpObj.showCorrect()", 300));
};
mpObj.drawNewLine = function(m,n,x1,y1,x2,y2) {
	mpObj.obj.choices[m] = n;
	if (mphObj.isIE) {
		var mp = mphMain.document.createElement("v:line");
		mp.id = "mpLine"+m;
		mp.style.position = "absolute";
		mp.style.left = "0px";
		mp.style.top = "0px";
		mp.from = x1+","+y1;
		mp.to = (x2+3)+","+y2;
		mp.strokeweight = "4px";
		mp.strokecolor = mphObj.lineColour;
		var mps = mphMain.document.createElement("v:shadow");
		mps.on = "true";
		mps.offset = "3px,3px";
		mps.color = mphObj.lineShadow;
		mps.opacity="0.5";
		mp.appendChild(mps);
		mphMain.document.body.appendChild(mp);
		
	} else {
		mpObj.obj.jg[m] = new jsGraphics("canvas"+m,mphMain);
		mpObj.obj.jg[m].setColor(mphObj.lineShadow);
		mpObj.obj.jg[m].setStroke(4);
		mpObj.obj.jg[m].drawLine(x1,y1+2,x2,y2+2);
		mpObj.obj.jg[m].setColor(mphObj.lineColour);
		mpObj.obj.jg[m].setStroke(4);
		mpObj.obj.jg[m].drawLine(x1,y1,x2,y2);
		mpObj.obj.jg[m].paint();
		
	}
};
mpObj.removeLine = function(m) {
	var tmp;
	if (mphObj.isIE) {
		if (tmp=mphMain.document.getElementById("mpLine"+m)) {
			mphMain.document.body.removeChild(tmp);
		}
	} else {
		if (mpObj.obj.choices[m]!="none") {
			mpObj.obj.jg[m].clear();
			mpObj.obj.choices[m] ="none";
		}
	}
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////
// 5. Part Identification ///////////////////////////////////////////////////////////////////////////////
var piObj = {};

piObj.question = function(num, hi) {
	// add the Q icon to the panel
	mph.qToPanels();
	mphObj.currQtype = "pi";
	// Update question number in "footer"
	if (mphObj.isTest) mph.updateQuestionNum(mphObj.currPage);
	
	piObj.obj = {};
	piObj.obj.partBgID 	= mphMain.document.getElementById("partsBg");
	piObj.obj.partsImg 	= mphMain.document.getElementById("partsImg");
	piObj.obj.container = mphMain.document.getElementById("container");
	piObj.obj.doneID   	= mphMain.document.getElementById("done");
	
	// num required correct for question to be answered
	piObj.obj.numRequired = num || 1;
	// set the highlight color
	piObj.obj.hilite = hi || "#00FF00";
	// holds references (IDs) to the correct options
	piObj.obj.options = [];
	// holds the position(s) of the correct option(s)
	piObj.obj.correctOption = [];
	// holds references (IDs) to the user's selection points
	piObj.obj.point = [];
	// holds the position(s) of the user's selection(s)
	piObj.obj.pos = [];
	// was the question answered correctly
	piObj.obj.answered = null;
	
	// init LMS question tracking
	if (mphPrefs.LMS) {
		piObj.obj.startTime = new Date().getTime();
		
		var a = mphObj.currPage;	// id
		var b = mphObj.currTopicNum;// current topic
		// correct response
		var c = "Select an appropriate area or areas";
		var d = mphObj.currQtype;	// question type
		var e = piObj.obj.startTime;// start time in ms
		
		mphLMS.scormInteractionInit(a, b, c, d, e);
	}
	
	if (!mphObj.isTest && !mphPrefs.nextEnabled) mph.disableNext();
	if (mphObj.isTest && mphPrefs.assessTimeLimit) mph.timeLimit();
	if (mphObj.isTest) piObj.obj.doneID.style.visibility = (mphPrefs.assessDoneVisible)?"visible":"hidden";
		else piObj.obj.doneID.style.visibility = (mphPrefs.doneVisible)?"visible":"hidden";
	
	piObj.obj.numOptions = 0;
	var tmp = [];
	while (mphMain.document.getElementById("option"+piObj.obj.numOptions)) {
		piObj.obj.point[piObj.obj.numOptions] = false;
		piObj.obj.options[piObj.obj.numOptions] = mphMain.document.getElementById("option"+piObj.obj.numOptions)
		// Get correct option position
		piObj.obj.correctOption[piObj.obj.numOptions] = [];
		tmp[0]= parseInt(piObj.obj.options[piObj.obj.numOptions].style.left, 10);
		tmp[1] = parseInt(piObj.obj.options[piObj.obj.numOptions].style.top, 10);
		tmp[2] = parseInt(piObj.obj.options[piObj.obj.numOptions].style.width, 10);
		tmp[3] = parseInt(piObj.obj.options[piObj.obj.numOptions].style.height, 10);
		// left
		piObj.obj.correctOption[piObj.obj.numOptions][0] = tmp[0];
		// top
		piObj.obj.correctOption[piObj.obj.numOptions][1] = tmp[1];
		// right
		piObj.obj.correctOption[piObj.obj.numOptions][2] = tmp[0] + tmp[2];
		// bottom
		piObj.obj.correctOption[piObj.obj.numOptions][3] = tmp[1] + tmp[3];
		
		piObj.obj.options[piObj.obj.numOptions].style.display = "none";
		
		piObj.obj.numOptions++;
	}
	
	piObj.obj.partsImg.onclick = piObj.showPoint;
	
	piObj.obj.doneID.onclick = piObj.feedback;
	piObj.obj.doneID.style.cursor = mphObj.mphCursor;
	piObj.obj.doneID.onmouseover = function() { this.style.backgroundPosition = "0 -"+mphObj.btnDoneHeight+"px" };
	piObj.obj.doneID.onmouseout =  function() { this.style.backgroundPosition = "0 0" };
	
	if (mphObj.isTest && typeof mphAssessScore[mphObj.currPage]!='undefined' && mphAssessScore[mphObj.currPage]!=null) piObj.rebuildQuestion();
		else mph.resultTally(piObj.obj.answered);
		
	mphMain.document.onkeyup = piObj.detectDel;
};
// show a marker at the click point
piObj.showPoint = function(e) {
	e = e || mphMain.event;
	mph.stopEventBubble(e);
	
	// num is one based
	var num = piObj.obj.point.find(false);
	if (!num) return;
	num -= 1;
	var a = parent.mph.getElementPositionAndSize(piObj.obj.container);
	var x = e.clientX - a[0] + piObj.obj.partBgID.scrollLeft - 7;
	var y = e.clientY - a[1] + piObj.obj.partBgID.scrollTop - 7;
	
	piObj.currentPoint = piObj.insertPoint(x,y,num);
	piObj.obj.point[num] = piObj.currentPoint;
	
	if (mphObj.isTest && !mphPrefs.assessDoneVisible) piObj.feedback();
	if (!mphObj.isTest && !mphPrefs.doneVisible) piObj.feedback();
};
piObj.hiPoint = function(e) {
	e = e || mphMain.event;
	mph.stopEventBubble(e);
	
	piObj.currentPoint = (e.target ? e.target: e.srcElement);
	
	for (var i = 0; i < piObj.obj.numOptions; i++) {
		if (piObj.obj.point[i]) piObj.obj.point[i].style.backgroundColor = "";
	}
	piObj.currentPoint.style.backgroundColor = "white";
};
piObj.detectDel = function(e) {
	e = e || mphMain.event;
	var charCode = (e.charCode) ? e.charCode :
				  ((e.keyCode) ? e.keyCode : 
				  ((e.which) ? e.which : 0));
	// Delete key pressed
	if (charCode == 46) piObj.removePoint();
};
piObj.removePoint = function() {
	if (!piObj.currentPoint) return;
	
	var tmp = piObj.obj.point.find(piObj.currentPoint);
	tmp -= 1;
	piObj.obj.point[tmp].onclick = null;
	piObj.obj.point[tmp].onmousedown = null;
	piObj.obj.point[tmp].onmouseup = null;
	piObj.obj.point[tmp] = false;
	piObj.obj.pos[tmp] = [];
	
	piObj.obj.container.removeChild(piObj.currentPoint);
	piObj.currentPoint = false;
};
piObj.removeAllPoints = function() {
	for (var i = 0; i < piObj.obj.numOptions; i++) {
		piObj.obj.point[i].onclick = null;
		piObj.obj.point[i].onmousedown = null;
		piObj.obj.point[i].onmouseup = null;
		if (piObj.obj.point[i]) piObj.obj.container.removeChild(piObj.obj.point[i]);
		piObj.obj.point[i] = false;
	}
	piObj.currentPoint = false;
};
piObj.insertPoint = function(x, y, num){
	for (var i = 0; i < piObj.obj.numOptions; i++) {
		if (piObj.obj.point[i]) piObj.obj.point[i].style.backgroundColor = "";
	}
	x = x || 0;
	y = y || 0;
	
	var point = mphMain.document.createElement("div");
	point.id = "point"+num;
	point.onclick = piObj.hiPoint;
	point.className = "point";	
	point.style.left = x +"px";
	point.style.top = y +"px";
	point.style.backgroundColor = "white";
	piObj.obj.container.appendChild(point);
	
	piObj.obj.pos[num] = [x, y];
	
	Drag.init(point, null, 0, parseInt(piObj.obj.partsImg.style.width,10)-15, 0, parseInt(piObj.obj.partsImg.style.height,10)-15);
	point.onDragEnd = piObj.updatePostions;
	
	return mphMain.document.getElementById("point"+num);
};
piObj.updatePostions = function(){
	var x, y;
	for (var i = 0; i < piObj.obj.numOptions; i++) {
		if (piObj.obj.point[i]) {
			x = parseInt(piObj.obj.point[i].style.left,10) + 7;
			y = parseInt(piObj.obj.point[i].style.top, 10) + 7;
			piObj.obj.pos[i] = [x, y];
		}
	}
};
piObj.pointInRect = function(aPt, aRect){
	/*
	 * Point (array) x, y
	 * Rect (array) left, top, right, bottom
	 */
	if (!aPt || aPt.length != 2) return false;
	if (!aRect || aRect.length != 4) return false;
	if (aPt[0] >= aRect[0] &&
		aPt[0] <= aRect[2] &&
		aPt[1] >= aRect[1] &&
		aPt[1] <= aRect[3]) {
		return true;
	}
	else {
		return false;
	}	
};
piObj.feedback = function() {
	if (mphObj.isTest && mphPrefs.assessMemory) mphMem[mphObj.currPage] = piObj.obj.pos;
	
	// has the question been answered correctly?
	var counter = 0;
	var tmp = piObj.obj.pos;
	for (var j = 0; j < piObj.obj.numOptions; j++) {
		for (var i = 0; i < piObj.obj.numOptions; i++) {
			if (piObj.pointInRect(tmp[i], piObj.obj.correctOption[j])) {
				counter++;
				delete tmp[i];
				break;
			}
		}
	}
	piObj.obj.answered = (counter >= piObj.obj.numRequired);
	
	// LMS tracking every question
	if (mphPrefs.LMS) {
		piObj.obj.time = new Date();
		var a = piObj.obj.startTime;		// start time
		var b = piObj.obj.time.getTime();	// end time in ms
		var c = piObj.obj.answered;			// result
		var d = "";							// user response
		
		mphLMS.scormInteractionSet(a, b, c, d);
	}
	
	mph.resultTally(piObj.obj.answered);
	
	piObj.lockQuestion();
	
	if (mphObj.isTest) {
		if (mphPrefs.assessShowCorrect && !piObj.obj.answered) piObj.showCorrect();	
		if (!mphPrefs.assessShowCorrect && !piObj.obj.answered) mph.feedback(piObj.obj.answered);
	} else {
		if (mphPrefs.showCorrect && !piObj.obj.answered) piObj.showCorrect();	
		if (!mphPrefs.showCorrect && !piObj.obj.answered) mph.feedback(piObj.obj.answered);
	}
	
	if (piObj.obj.answered) mph.feedback(piObj.obj.answered);
};
piObj.lockQuestion = function() {
	piObj.obj.partsImg.style.cursor = "default";
	piObj.obj.partsImg.onclick = null;
	
	mphMain.document.onkeyup = null;
	
	for (var i = 0; i < piObj.obj.numOptions; i++) {
		if (piObj.obj.point[i]) {
			piObj.obj.point[i].onclick = null;
			piObj.obj.point[i].onmousedown = null;
			piObj.obj.point[i].onmouseup = null;
			piObj.obj.point[i].style.backgroundColor = "";
		}
	}
	
	// hide the done button
	piObj.obj.doneID.style.visibility = "hidden";
};
piObj.resetQuestion = function() {
	piObj.obj.pos = [];
	
	piObj.obj.partsImg.style.cursor = mphObj.mphCursor;
	piObj.obj.partsImg.onclick = piObj.showPoint;
	
	mphMain.document.onkeyup = piObj.detectDel;
	
	// remove points
	piObj.removeAllPoints();
	
	// show the done button
	if (mphObj.isTest) piObj.obj.doneID.style.visibility = (mphPrefs.assessDoneVisible)?"visible":"hidden";
		else piObj.obj.doneID.style.visibility = (mphPrefs.doneVisible)?"visible":"hidden";
};
piObj.rebuildQuestion = function() {
	var x, y;
	if (typeof mphMem[mphObj.currPage] != 'undefined') {
		if (mphPrefs.assessMemory) {
			for (var i = 0; i < piObj.obj.numOptions; i++) {
				if (mphMem[mphObj.currPage][i]) {
					x = mphMem[mphObj.currPage][i][0];
					y = mphMem[mphObj.currPage][i][1];
					piObj.currentPoint = piObj.insertPoint(x, y, i);
					piObj.obj.point[i] = piObj.currentPoint;
				}
			}
		} else {
			// is another attempt permitted
			piObj.lockQuestion();
		}
	}
};
piObj.showCorrect = function() {
	for (var i = 0; i < piObj.obj.options.length; i++) {
		piObj.obj.options[i].style.display = "";
		piObj.obj.options[i].style.left	= parseInt(piObj.obj.options[i].style.left,10) - 1 + "px";
		piObj.obj.options[i].style.top		= parseInt(piObj.obj.options[i].style.top,10) - 1 + "px";
		piObj.obj.options[i].style.width	= parseInt(piObj.obj.options[i].style.width,10) - 2 + "px";
		piObj.obj.options[i].style.height	= parseInt(piObj.obj.options[i].style.height,10) - 2 + "px";
		piObj.obj.options[i].style.border	= "3px dotted " + piObj.obj.hilite;
	}
	piObj.obj.options[0].scrollIntoView(false);
	mphObj.timeouts.push(setTimeout("mph.feedback(piObj.obj.answered)", 300) );
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////
// 6. Free form test entry //////////////////////////////////////////////////////////////////////////////
ftObj = function(obj,num,rec,lim,ev,whole,caseSen,mem,prnt,qnum) {
	// add the Q icon to the panel
	mph.qToPanels();
	mphObj.currQtype = "ft";
	// Update question number in "footer"
	if (mphObj.isTest) mph.updateQuestionNum(mphObj.currPage);
	
	this.optionIDs 		= [obj];
	this.num 			= num;
	this.recordText 	= rec;
	this.limit 			= lim;
	this.evaluate 		= ev;
	this.whole 			= whole;
	this.caseSensitive 	= caseSen;
	this.mem 			= mem;
	this.print 			= prnt;
	this.qnum			= qnum;
	
	this.doneID = mphMain.document.getElementById("done");
	this.answered = null;
	this.re = [];
	
	if (this.print) this.addPrintButton();
	
	if (this.limit!=0) {
		this.optionIDs[0].onchange = this.checkMaxLength.bind(this);
		this.optionIDs[0].onkeyup = this.checkMaxLength.bind(this);
	}
	
	this.optionIDs[0].style.fontFamily = mph.getElStyle(mphMain.document.body,"fontFamily","font-family");

	if (!mphObj.isTest && !mphPrefs.nextEnabled) mph.disableNext();
	
	if (mphObj.isTest && mphPrefs.assessTimeLimit) mph.timeLimit();

	this.doneID.onclick = this.feedback.bind(this);
	this.doneID.onmouseover = function() { this.style.backgroundPosition = "0 -"+mphObj.btnDoneHeight+"px" };
	this.doneID.onmouseout =  function() { this.style.backgroundPosition = "0 0" };
	if (mphObj.isTest) this.doneID.style.visibility = (mphPrefs.assessDoneVisible)?"visible":"hidden";
		else this.doneID.style.visibility = (mphPrefs.doneVisible)?"visible":"hidden";
	
	var cook = this.mem?this.readCookie(mphObj.currPage):false;
	if (!cook && typeof mphMem[mphObj.currPage] == 'undefined') mph.resultTally(this.answered);
		else this.optionIDs[0].value = (cook?cook:"");
	
	this.currPage = this.write();
	
	// init LMS question tracking
	if (mphPrefs.LMS) {
		this.startTime = new Date().getTime();
		
		var a = mphObj.currPage;								// id
		var b = mphObj.currTopicNum;						// current topic
		// correct response
		var c = this.currPage.join(" ");
		var d = mphObj.currQtype;								// question type
		var e = this.startTime;									// start time in ms
		
		mphLMS.scormInteractionInit(a, b, c, d, e);
	}
};
ftObj.prototype.checkMaxLength = function() {
	if (this.optionIDs[0].value.length>this.limit) this.optionIDs[0].value = this.optionIDs[0].value.substr(0,this.limit);
};
ftObj.prototype.feedback = function() {
	var numCorrect = 0, re, whole = "", caseSen = "i", i, j, tmp;
	this.optionIDs[0].readOnly = true;
	// reduce multiple spaces
	var currValue = this.optionIDs[0].value.replace(/\s+/g," ");
	mphMem[mphObj.currPage] = true;
	if (this.whole) whole = "\\b";
	if (this.caseSensitive) caseSen = "";
	
	for (i=0; i<this.currPage.length; i++) {
		if (typeof this.currPage[i].sort == 'function') {
			for (j=0; j<this.currPage[i].length; j++) {
				re = new RegExp(whole+this.currPage[i][j]+whole, "g"+caseSen);
				
				tmp = re.test(currValue);
				if (tmp) {
					numCorrect++;
					break;
				}
			}
		} else {
			re = new RegExp(whole+this.currPage[i]+whole, caseSen);
			tmp = re.test(currValue);
			if (tmp) {
				numCorrect++;
			}
		}
	}
	
	// has the question been answered correctly?
	this.answered = true;
	if (this.evaluate) {
		this.answered = false;
		if (!this.num && numCorrect==this.currPage.length) this.answered = true;
			else if (this.num && numCorrect>=this.num) this.answered = true;
	}
	
	currValue = currValue.replace(/'/g, "");
	
	// LMS tracking every question
	if (mphPrefs.LMS) {
		this.time = new Date();
		var a = this.startTime;		// start time
		var b = this.time.getTime();// end time in ms
		var c = this.answered;		// result
		var d = currValue;			// user response
		if ((d.length>250) && (mphLMS.scormVersion == 12)) d = d.substring(0,250);
		
		mphLMS.scormInteractionSet(a, b, c, d);
	}
	
	mph.resultTally(this.answered);
	
	this.lockQuestion();
	
	mph.feedback(this.answered,this);

	if (this.recordText && !mphPrefs.LMS) this.record(currValue);
	if (this.email && mphPrefs.record && mphPrefs.sendEmail) {
		var str = " "+this.qnum+". ["+mphObj.currPage+"] "+currValue;
		mph.message({kind:"email",email:str});
	}
	
	if (this.mem) this.createCookie(mphObj.currPage,currValue);
};
ftObj.prototype.lockQuestion = function() {
	this.optionIDs[0].readOnly = true;
	this.doneID.style.visibility = "hidden";	
};
ftObj.prototype.resetQuestion = function() {
	this.optionIDs[0].readOnly = false;
	this.optionIDs[0].value = "";
	// show the done button
	if (mphObj.isTest) this.doneID.style.visibility = (mphPrefs.assessDoneVisible)?"visible":"hidden";
		else this.doneID.style.visibility = (mphPrefs.doneVisible)?"visible":"hidden";
};
ftObj.prototype.record = function(val) {
	if (mphPrefs.localDB) this.localDB(val);
	else if (mphPrefs.webDB) this.webDB(val);
};
ftObj.prototype.localDB = function(val) {
	mphDB2.addResponse(this.qnum, val, this.tableName);
};
ftObj.prototype.webDB = function(val) {
	var val = val.replace(/'/g, "");

	var frm = mphMain.document.getElementById("ftForm");
	
	mphMain.document.getElementById("ftCode").value 	= mphPrefs.courseCode;
	mphMain.document.getElementById("ftValue").value	= this.qnum+". "+val;
	mphMain.document.getElementById("ftPage").value		= mphObj.currPage;
	if (mphObj.projectSuf == ".php") {
		mphMain.document.getElementById("ftName").value = mphObj.mphname;
		mphMain.document.getElementById("ftId").value 	= mphObj.mphID;
		mphMain.document.getElementById("ftPwd").value 	= mphObj.mphpwd;
		frm.action = "include/recordtext.php";
	} else {
		frm.action = "include/recordtext.asp";
	}
	
	frm.submit();
};
ftObj.prototype.write = function() {
	var i, j, len, len2, tmp = [], k = mphObj.currPage;
	var val = quest[mphObj.currPage];
	
	if (typeof val.sort == 'function') {
		for (i = 0, len = val.length; i<len; i++) {
			if (typeof val[i].sort == 'function') {
				tmp[i] = [];
				for (j = 0, len2 = val[i].length; j<len2; j++) tmp[i][j] = this.read(val[i][j],k);
			} else {
				tmp[i] = this.read(val[i],k);
			}
		}
	} else {
		tmp[0] = this.read(val,k);
	}
	
	return tmp;
};
ftObj.prototype.read = function(val, k) {
	val += "";
	var i;
	if (k.length == 0) return;
	var r = "", c = [];
	var kl = k.length;
	var a = val.split("-");
	for (i = 0; i < kl; i++) c[i] = k.charCodeAt(i);
	for (i = 0; i < a.length-1; i++) r += String.fromCharCode(a[i] - c[i%kl]);
	
	return r;
};
ftObj.prototype.createCookie = function (name,value) {
	mphMain.document.cookie = name+"="+value+"; path=/";
};
ftObj.prototype.readCookie = function (name) {
	var nameEQ = name + "=";
	var ca = mphMain.document.cookie.split(';');
	for(var i=0;i < ca.length;i++) {
		var c = ca[i];
		while (c.charAt(0)==' ') c = c.substring(1,c.length);
		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
	}
	return null;
};
ftObj.prototype.addPrintButton = function() {
	var dv = mphMain.document.createElement("div");
	dv.style.position 	= "absolute";
	dv.style.left 		= "889px";
	dv.style.top 		= "10px";
	dv.style.width		= "80px";
	dv.style.overflow	= "hidden";
	
	var inpt = mphMain.document.createElement("input");
	inpt.className		= "print";
	inpt.type 			= "button";
	inpt.value			= "Print";
	inpt.style.width	= "100%";
	inpt.style.cursor 	= "pointer";
	inpt.onclick		= this.printPreview.bind(this);
	
	dv.appendChild(inpt);
	mphMain.document.body.appendChild(dv);
};
ftObj.prototype.printPreview = function(e,elem) {
	var nw = new Date();
	var now = nw.toString();
	
	var cQ = mphMain.document.getElementById("upperpanellarge").getElementsByTagName("p")[0];
	var currQ = cQ.firstChild.nodeValue;
	
	var currValue = this.optionIDs[0].value;
	
	var printWin = window.open("", "newPrintWin", '');
	printWin.document.write("<h2>"+parent.mphPrefs.courseName+"</h2>");
	printWin.document.write("<p>"+now+"</p>");
	printWin.document.write(currQ);
	printWin.document.write("<p>Response:</p>");
	printWin.document.write(currValue);
	printWin.document.close();
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////
// 7. custom question ///////////////////////////////////////////////////////////////////////////////////
// This is to manage a custom question inserted by a developer
// Currently only SWF and Java are supported.
customObj = function(typ) {
	mphObj.currQtype = typ;
	
	// init LMS question tracking
	if (mphPrefs.LMS) {
		this.startTime = new Date().getTime();
		
		var a = mphObj.currPage;								// id
		var b = mphObj.currTopicNum;						// current topic
		// correct response
		var c;
		if (mphObj.currQtype=="swf") c = "Flash SWF question";
			else if (mphObj.currQtype=="java") c = "Java question";
			else c = "Undefined question type";
		var d = mphObj.currQtype;								// question type
		var e = this.startTime;									// start time in ms
		
		mphLMS.scormInteractionInit(a, b, c, d, e);
	}
	
	// the object tag affects the positioning of the embed tag
	if (!mphObj.isIE && mphObj.currQtype=="swf") {
		var axFlash = false;
		if (window.ActiveXObject) {
			try {
				var ax = new ActiveXObject("ShockwaveFlash.ShockwaveFlash");
				axFlash = true;
				delete ax;
			} catch (oErr) {
				;
			}
		}
		if (!axFlash) {
			mphMain.document.getElementById("mmSWF").style.left = 0;
			mphMain.document.getElementById("mmSWF").style.top = 0;
			mphMain.document.getElementById("mmSWF").style.width = "100%";
			mphMain.document.getElementById("mmSWF").style.height = "100%";
		}
	} else if (mphObj.isIE && mphObj.currQtype=="java") {
		if (mphMain.document.getElementById("mmJava").style.width == "100%")
			mphMain.document.getElementById("mmJava").style.setExpression("width","document.body.offsetWidth");
	}
	// Update question number in "footer"
	if (mphObj.isTest) mph.updateQuestionNum(mphObj.currPage);
	
	if (!mphObj.isTest && !mphPrefs.nextEnabled) mph.disableNext();	
	if (mphObj.isTest && mphPrefs.assessTimeLimit) mph.timeLimit();
};
// if question answered correctly call with a value of true, else false
customObj.prototype.answered = function(val) {
	// LMS tracking every question
	if (mphPrefs.LMS) {
		this.time = new Date();
		var a = this.startTime;							// start time
		var b = this.time.getTime();				// end time in ms
		var c = val;												// result
		var d = "";													// user response
		
		mphLMS.scormInteractionSet(a, b, c, d);
	}
	
	mphMem[mphObj.currPage] = true;
	if (!val || val=="false") val = null;
	mph.resultTally(val);
};
// call to activate/move next
customObj.prototype.next = function() {
	if (mphPrefs.nextVisible) mph.enableNext();
		else mph.navOnclick(3);
};
/* This notice must be untouched at all times.

wz_jsgraphics.js    v. 3.03
The latest version is available at
http://www.walterzorn.com
or http://www.devira.com
or http://www.walterzorn.de

Copyright (c) 2002-2004 Walter Zorn. All rights reserved.
Created 3. 11. 2002 by Walter Zorn (Web: http://www.walterzorn.com )
Last modified: 28. 1. 2008

Performance optimizations for Internet Explorer
by Thomas Frank and John Holdsworth.
fillPolygon method implemented by Matthieu Haller.

High Performance JavaScript Graphics Library.
Provides methods
- to draw lines, rectangles, ellipses, polygons
	with specifiable line thickness,
- to fill rectangles, polygons, ellipses and arcs
- to draw text.
NOTE: Operations, functions and branching have rather been optimized
to efficiency and speed than to shortness of source code.

LICENSE: LGPL

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License (LGPL) as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA,
or see http://www.gnu.org/copyleft/lesser.html
*/

var jg_ok, jg_ie, jg_fast, jg_dom, jg_moz;

function _chkDHTM(x, i) {
	x = document.body || null;
	jg_ie = x && typeof x.insertAdjacentHTML != "undefined" && document.createElement;
	jg_dom = (x && !jg_ie &&
		typeof x.appendChild != "undefined" &&
		typeof document.createRange != "undefined" &&
		typeof (i = document.createRange()).setStartBefore != "undefined" &&
		typeof i.createContextualFragment != "undefined");
	jg_fast = jg_ie && document.all && !window.opera;
	jg_moz = jg_dom && typeof x.style.MozOpacity != "undefined";
	jg_ok = !!(jg_ie || jg_dom);
}
function _pntCnvDom() {
	var x = this.wnd.document.createRange();
	x.setStartBefore(this.cnv);
	x = x.createContextualFragment(jg_fast? this._htmRpc() : this.htm);
	if(this.cnv) this.cnv.appendChild(x);
	this.htm = "";
}
function _pntCnvIe() {
	if(this.cnv) this.cnv.insertAdjacentHTML("BeforeEnd", jg_fast? this._htmRpc() : this.htm);
	this.htm = "";
}
function _pntDoc() {
	this.wnd.document.write(jg_fast? this._htmRpc() : this.htm);
	this.htm = '';
}
function _pntN() {
	;
}
function _mkDiv(x, y, w, h) {
	this.htm += '<div style="position:absolute;'+
		'left:' + x + 'px;'+
		'top:' + y + 'px;'+
		'width:' + w + 'px;'+
		'height:' + h + 'px;'+
		'clip:rect(0,'+w+'px,'+h+'px,0);'+
		'background-color:' + this.color +
		(!jg_moz? ';overflow:hidden' : '')+
		';"><\/div>';
}
function _mkDivIe(x, y, w, h) {
	this.htm += '%%'+this.color+';'+x+';'+y+';'+w+';'+h+';';
}
function _mkDivPrt(x, y, w, h) {
	this.htm += '<div style="position:absolute;'+
		'border-left:' + w + 'px solid ' + this.color + ';'+
		'left:' + x + 'px;'+
		'top:' + y + 'px;'+
		'width:0px;'+
		'height:' + h + 'px;'+
		'clip:rect(0,'+w+'px,'+h+'px,0);'+
		'background-color:' + this.color +
		(!jg_moz? ';overflow:hidden' : '')+
		';"><\/div>';
}
var _regex =  /%%([^;]+);([^;]+);([^;]+);([^;]+);([^;]+);/g;
function _htmRpc() {
	return this.htm.replace(
		_regex,
		'<div style="overflow:hidden;position:absolute;background-color:'+
		'$1;left:$2;top:$3;width:$4;height:$5"></div>\n');
}
function _htmPrtRpc() {
	return this.htm.replace(
		_regex,
		'<div style="overflow:hidden;position:absolute;background-color:'+
		'$1;left:$2;top:$3;width:$4;height:$5;border-left:$4px solid $1"></div>\n');
}
function _mkLin(x1, y1, x2, y2) {
	if(x1 > x2) {
		var _x2 = x2;
		var _y2 = y2;
		x2 = x1;
		y2 = y1;
		x1 = _x2;
		y1 = _y2;
	}
	var dx = x2-x1, dy = Math.abs(y2-y1),
	x = x1, y = y1,
	yIncr = (y1 > y2)? -1 : 1;

	if(dx >= dy) {
		var pr = dy<<1,
		pru = pr - (dx<<1),
		p = pr-dx,
		ox = x;
		while(dx > 0) {
			--dx;
			++x;
			if(p > 0) {
				this._mkDiv(ox, y, x-ox, 1);
				y += yIncr;
				p += pru;
				ox = x;
			} else p += pr;
		}
		this._mkDiv(ox, y, x2-ox+1, 1);
	} else {
		var pr = dx<<1,
		pru = pr - (dy<<1),
		p = pr-dy,
		oy = y;
		if(y2 <= y1) {
			while(dy > 0) {
				--dy;
				if(p > 0) {
					this._mkDiv(x++, y, 1, oy-y+1);
					y += yIncr;
					p += pru;
					oy = y;
				} else {
					y += yIncr;
					p += pr;
				}
			}
			this._mkDiv(x2, y2, 1, oy-y2+1);
		} else {
			while(dy > 0) {--dy;
				y += yIncr;
				if(p > 0) {
					this._mkDiv(x++, oy, 1, y-oy);
					p += pru;
					oy = y;
				} else p += pr;
			}
			this._mkDiv(x2, oy, 1, y2-oy+1);
		}
	}
}
function _mkLin2D(x1, y1, x2, y2) {
	if(x1 > x2) {
		var _x2 = x2;
		var _y2 = y2;
		x2 = x1;
		y2 = y1;
		x1 = _x2;
		y1 = _y2;
	}
	var dx = x2-x1, dy = Math.abs(y2-y1),
	x = x1, y = y1,
	yIncr = (y1 > y2)? -1 : 1;

	var s = this.stroke;
	if(dx >= dy) {
		if(dx > 0 && s-3 > 0) {
			var _s = (s*dx*Math.sqrt(1+dy*dy/(dx*dx))-dx-(s>>1)*dy) / dx;
			_s = (!(s-4)? Math.ceil(_s) : Math.round(_s)) + 1;
		}
		else var _s = s;
		var ad = Math.ceil(s/2);

		var pr = dy<<1,
		pru = pr - (dx<<1),
		p = pr-dx,
		ox = x;
		while(dx > 0) {
			--dx;
			++x;
			if(p > 0) {
				this._mkDiv(ox, y, x-ox+ad, _s);
				y += yIncr;
				p += pru;
				ox = x;
			} else p += pr;
		}
		this._mkDiv(ox, y, x2-ox+ad+1, _s);
	} else {
		if(s-3 > 0) {
			var _s = (s*dy*Math.sqrt(1+dx*dx/(dy*dy))-(s>>1)*dx-dy) / dy;
			_s = (!(s-4)? Math.ceil(_s) : Math.round(_s)) + 1;
		}
		else var _s = s;
		var ad = Math.round(s/2);

		var pr = dx<<1,
		pru = pr - (dy<<1),
		p = pr-dy,
		oy = y;
		if(y2 <= y1) {
			++ad;
			while(dy > 0) {
				--dy;
				if(p > 0) {
					this._mkDiv(x++, y, _s, oy-y+ad);
					y += yIncr;
					p += pru;
					oy = y;
				} else {
					y += yIncr;
					p += pr;
				}
			}
			this._mkDiv(x2, y2, _s, oy-y2+ad);
		} else {
			while(dy > 0) {
				--dy;
				y += yIncr;
				if(p > 0) {
					this._mkDiv(x++, oy, _s, y-oy+ad);
					p += pru;
					oy = y;
				} else p += pr;
			}
			this._mkDiv(x2, oy, _s, y2-oy+ad+1);
		}
	}
}
function _mkLinDott(x1, y1, x2, y2) {
	if(x1 > x2) {
		var _x2 = x2;
		var _y2 = y2;
		x2 = x1;
		y2 = y1;
		x1 = _x2;
		y1 = _y2;
	}
	var dx = x2-x1, dy = Math.abs(y2-y1),
	x = x1, y = y1,
	yIncr = (y1 > y2)? -1 : 1,
	drw = true;
	if(dx >= dy) {
		var pr = dy<<1,
		pru = pr - (dx<<1),
		p = pr-dx;
		while(dx > 0) {
			--dx;
			if(drw) this._mkDiv(x, y, 1, 1);
			drw = !drw;
			if(p > 0) {
				y += yIncr;
				p += pru;
			} else p += pr;
			++x;
		}
	} else {
		var pr = dx<<1,
		pru = pr - (dy<<1),
		p = pr-dy;
		while(dy > 0) {
			--dy;
			if(drw) this._mkDiv(x, y, 1, 1);
			drw = !drw;
			y += yIncr;
			if(p > 0) {
				++x;
				p += pru;
			} else p += pr;
		}
	}
	if(drw) this._mkDiv(x, y, 1, 1);
}
function _mkOv(left, top, width, height) {
	var a = (++width)>>1, b = (++height)>>1,
	wod = width&1, hod = height&1,
	cx = left+a, cy = top+b,
	x = 0, y = b,
	ox = 0, oy = b,
	aa2 = (a*a)<<1, aa4 = aa2<<1, bb2 = (b*b)<<1, bb4 = bb2<<1,
	st = (aa2>>1)*(1-(b<<1)) + bb2,
	tt = (bb2>>1) - aa2*((b<<1)-1),
	w, h;
	while(y > 0) {
		if(st < 0) {
			st += bb2*((x<<1)+3);
			tt += bb4*(++x);
		} else if(tt < 0) {
			st += bb2*((x<<1)+3) - aa4*(y-1);
			tt += bb4*(++x) - aa2*(((y--)<<1)-3);
			w = x-ox;
			h = oy-y;
			if((w&2) && (h&2)) {
				this._mkOvQds(cx, cy, x-2, y+2, 1, 1, wod, hod);
				this._mkOvQds(cx, cy, x-1, y+1, 1, 1, wod, hod);
			}
			else this._mkOvQds(cx, cy, x-1, oy, w, h, wod, hod);
			ox = x;
			oy = y;
		} else {
			tt -= aa2*((y<<1)-3);
			st -= aa4*(--y);
		}
	}
	w = a-ox+1;
	h = (oy<<1)+hod;
	y = cy-oy;
	this._mkDiv(cx-a, y, w, h);
	this._mkDiv(cx+ox+wod-1, y, w, h);
}
function _mkOv2D(left, top, width, height) {
	var s = this.stroke;
	width += s+1;
	height += s+1;
	var a = width>>1, b = height>>1,
	wod = width&1, hod = height&1,
	cx = left+a, cy = top+b,
	x = 0, y = b,
	aa2 = (a*a)<<1, aa4 = aa2<<1, bb2 = (b*b)<<1, bb4 = bb2<<1,
	st = (aa2>>1)*(1-(b<<1)) + bb2,
	tt = (bb2>>1) - aa2*((b<<1)-1);

	if(s-4 < 0 && (!(s-2) || width-51 > 0 && height-51 > 0)) {
		var ox = 0, oy = b,
		w, h,
		pxw;
		while(y > 0) {
			if(st < 0) {
				st += bb2*((x<<1)+3);
				tt += bb4*(++x);
			} else if(tt < 0) {
				st += bb2*((x<<1)+3) - aa4*(y-1);
				tt += bb4*(++x) - aa2*(((y--)<<1)-3);
				w = x-ox;
				h = oy-y;

				if(w-1) {
					pxw = w+1+(s&1);
					h = s;
				} else if(h-1) {
					pxw = s;
					h += 1+(s&1);
				} else pxw = h = s;
				this._mkOvQds(cx, cy, x-1, oy, pxw, h, wod, hod);
				ox = x;
				oy = y;
			} else {
				tt -= aa2*((y<<1)-3);
				st -= aa4*(--y);
			}
		}
		this._mkDiv(cx-a, cy-oy, s, (oy<<1)+hod);
		this._mkDiv(cx+a+wod-s, cy-oy, s, (oy<<1)+hod);
	} else {
		var _a = (width-(s<<1))>>1,
		_b = (height-(s<<1))>>1,
		_x = 0, _y = _b,
		_aa2 = (_a*_a)<<1, _aa4 = _aa2<<1, _bb2 = (_b*_b)<<1, _bb4 = _bb2<<1,
		_st = (_aa2>>1)*(1-(_b<<1)) + _bb2,
		_tt = (_bb2>>1) - _aa2*((_b<<1)-1),

		pxl = new Array(),
		pxt = new Array(),
		_pxb = new Array();
		pxl[0] = 0;
		pxt[0] = b;
		_pxb[0] = _b-1;
		while(y > 0) {
			if(st < 0) {
				pxl[pxl.length] = x;
				pxt[pxt.length] = y;
				st += bb2*((x<<1)+3);
				tt += bb4*(++x);
			} else if(tt < 0) {
				pxl[pxl.length] = x;
				st += bb2*((x<<1)+3) - aa4*(y-1);
				tt += bb4*(++x) - aa2*(((y--)<<1)-3);
				pxt[pxt.length] = y;
			} else {
				tt -= aa2*((y<<1)-3);
				st -= aa4*(--y);
			}

			if(_y > 0) {
				if(_st < 0) {
					_st += _bb2*((_x<<1)+3);
					_tt += _bb4*(++_x);
					_pxb[_pxb.length] = _y-1;
				} else if(_tt < 0) {
					_st += _bb2*((_x<<1)+3) - _aa4*(_y-1);
					_tt += _bb4*(++_x) - _aa2*(((_y--)<<1)-3);
					_pxb[_pxb.length] = _y-1;
				} else {
					_tt -= _aa2*((_y<<1)-3);
					_st -= _aa4*(--_y);
					_pxb[_pxb.length-1]--;
				}
			}
		}

		var ox = -wod, oy = b,
		_oy = _pxb[0],
		l = pxl.length,
		w, h;
		for(var i = 0; i < l; i++) {
			if(typeof _pxb[i] != "undefined") {
				if(_pxb[i] < _oy || pxt[i] < oy) {
					x = pxl[i];
					this._mkOvQds(cx, cy, x, oy, x-ox, oy-_oy, wod, hod);
					ox = x;
					oy = pxt[i];
					_oy = _pxb[i];
				}
			} else {
				x = pxl[i];
				this._mkDiv(cx-x, cy-oy, 1, (oy<<1)+hod);
				this._mkDiv(cx+ox+wod, cy-oy, 1, (oy<<1)+hod);
				ox = x;
				oy = pxt[i];
			}
		}
		this._mkDiv(cx-a, cy-oy, 1, (oy<<1)+hod);
		this._mkDiv(cx+ox+wod, cy-oy, 1, (oy<<1)+hod);
	}
}
function _mkOvDott(left, top, width, height) {
	var a = (++width)>>1, b = (++height)>>1,
	wod = width&1, hod = height&1, hodu = hod^1,
	cx = left+a, cy = top+b,
	x = 0, y = b,
	aa2 = (a*a)<<1, aa4 = aa2<<1, bb2 = (b*b)<<1, bb4 = bb2<<1,
	st = (aa2>>1)*(1-(b<<1)) + bb2,
	tt = (bb2>>1) - aa2*((b<<1)-1),
	drw = true;
	while(y > 0) {
		if(st < 0) {
			st += bb2*((x<<1)+3);
			tt += bb4*(++x);
		} else if(tt < 0) {
			st += bb2*((x<<1)+3) - aa4*(y-1);
			tt += bb4*(++x) - aa2*(((y--)<<1)-3);
		} else {
			tt -= aa2*((y<<1)-3);
			st -= aa4*(--y);
		}
		if(drw && y >= hodu) this._mkOvQds(cx, cy, x, y, 1, 1, wod, hod);
		drw = !drw;
	}
}
function _mkRect(x, y, w, h) {
	var s = this.stroke;
	this._mkDiv(x, y, w, s);
	this._mkDiv(x+w, y, s, h);
	this._mkDiv(x, y+h, w+s, s);
	this._mkDiv(x, y+s, s, h-s);
}
function _mkRectDott(x, y, w, h) {
	this.drawLine(x, y, x+w, y);
	this.drawLine(x+w, y, x+w, y+h);
	this.drawLine(x, y+h, x+w, y+h);
	this.drawLine(x, y, x, y+h);
}
function jsgFont() {
	this.PLAIN = 'font-weight:normal;';
	this.BOLD = 'font-weight:bold;';
	this.ITALIC = 'font-style:italic;';
	this.ITALIC_BOLD = this.ITALIC + this.BOLD;
	this.BOLD_ITALIC = this.ITALIC_BOLD;
}
var Font = new jsgFont();
function jsgStroke() {
	this.DOTTED = -1;
}
var Stroke = new jsgStroke();
function jsGraphics(cnv, wnd) {
	this.setColor = function(x) {
		this.color = x.toLowerCase();
	};
	this.setStroke = function(x) {
		this.stroke = x;
		if(!(x+1)) {
			this.drawLine = _mkLinDott;
			this._mkOv = _mkOvDott;
			this.drawRect = _mkRectDott;
		} else if(x-1 > 0) {
			this.drawLine = _mkLin2D;
			this._mkOv = _mkOv2D;
			this.drawRect = _mkRect;
		} else {
			this.drawLine = _mkLin;
			this._mkOv = _mkOv;
			this.drawRect = _mkRect;
		}
	};

	this.setPrintable = function(arg) {
		this.printable = arg;
		if(jg_fast) {
			this._mkDiv = _mkDivIe;
			this._htmRpc = arg? _htmPrtRpc : _htmRpc;
		} else this._mkDiv = arg? _mkDivPrt : _mkDiv;
	};

	this.setFont = function(fam, sz, sty) {
		this.ftFam = fam;
		this.ftSz = sz;
		this.ftSty = sty || Font.PLAIN;
	};

	this.drawPolyline = this.drawPolyLine = function(x, y) {
		for (var i=x.length - 1; i;){
			--i;
			this.drawLine(x[i], y[i], x[i+1], y[i+1]);
		}
	};

	this.fillRect = function(x, y, w, h) {
		this._mkDiv(x, y, w, h);
	};

	this.drawPolygon = function(x, y) {
		this.drawPolyline(x, y);
		this.drawLine(x[x.length-1], y[x.length-1], x[0], y[0]);
	};

	this.drawEllipse = this.drawOval = function(x, y, w, h) {
		this._mkOv(x, y, w, h);
	};

	this.fillEllipse = this.fillOval = function(left, top, w, h) {
		var a = w>>1, b = h>>1,
		wod = w&1, hod = h&1,
		cx = left+a, cy = top+b,
		x = 0, y = b, oy = b,
		aa2 = (a*a)<<1, aa4 = aa2<<1, bb2 = (b*b)<<1, bb4 = bb2<<1,
		st = (aa2>>1)*(1-(b<<1)) + bb2,
		tt = (bb2>>1) - aa2*((b<<1)-1),
		xl, dw, dh;
		if(w) while(y > 0) {
			if(st < 0) {
				st += bb2*((x<<1)+3);
				tt += bb4*(++x);
			} else if(tt < 0) {
				st += bb2*((x<<1)+3) - aa4*(y-1);
				xl = cx-x;
				dw = (x<<1)+wod;
				tt += bb4*(++x) - aa2*(((y--)<<1)-3);
				dh = oy-y;
				this._mkDiv(xl, cy-oy, dw, dh);
				this._mkDiv(xl, cy+y+hod, dw, dh);
				oy = y;
			} else {
				tt -= aa2*((y<<1)-3);
				st -= aa4*(--y);
			}
		}
		this._mkDiv(cx-a, cy-oy, w, (oy<<1)+hod);
	};

	this.fillArc = function(iL, iT, iW, iH, fAngA, fAngZ) {
		var a = iW>>1, b = iH>>1,
		iOdds = (iW&1) | ((iH&1) << 16),
		cx = iL+a, cy = iT+b,
		x = 0, y = b, ox = x, oy = y,
		aa2 = (a*a)<<1, aa4 = aa2<<1, bb2 = (b*b)<<1, bb4 = bb2<<1,
		st = (aa2>>1)*(1-(b<<1)) + bb2,
		tt = (bb2>>1) - aa2*((b<<1)-1),
		// Vars for radial boundary lines
		xEndA, yEndA, xEndZ, yEndZ,
		iSects = (1 << (Math.floor((fAngA %= 360.0)/180.0) << 3))
				| (2 << (Math.floor((fAngZ %= 360.0)/180.0) << 3))
				| ((fAngA >= fAngZ) << 16),
		aBndA = new Array(b+1), aBndZ = new Array(b+1);
		
		// Set up radial boundary lines
		fAngA *= Math.PI/180.0;
		fAngZ *= Math.PI/180.0;
		xEndA = cx+Math.round(a*Math.cos(fAngA));
		yEndA = cy+Math.round(-b*Math.sin(fAngA));
		_mkLinVirt(aBndA, cx, cy, xEndA, yEndA);
		xEndZ = cx+Math.round(a*Math.cos(fAngZ));
		yEndZ = cy+Math.round(-b*Math.sin(fAngZ));
		_mkLinVirt(aBndZ, cx, cy, xEndZ, yEndZ);

		while(y > 0) {
			if(st < 0) // Advance x
			{
				st += bb2*((x<<1)+3);
				tt += bb4*(++x);
			} else if(tt < 0) // Advance x and y
			{
				st += bb2*((x<<1)+3) - aa4*(y-1);
				ox = x;
				tt += bb4*(++x) - aa2*(((y--)<<1)-3);
				this._mkArcDiv(ox, y, oy, cx, cy, iOdds, aBndA, aBndZ, iSects);
				oy = y;
			} else // Advance y
			{
				tt -= aa2*((y<<1)-3);
				st -= aa4*(--y);
				if(y && (aBndA[y] != aBndA[y-1] || aBndZ[y] != aBndZ[y-1]))
				{
					this._mkArcDiv(x, y, oy, cx, cy, iOdds, aBndA, aBndZ, iSects);
					ox = x;
					oy = y;
				}
			}
		}
		this._mkArcDiv(x, 0, oy, cx, cy, iOdds, aBndA, aBndZ, iSects);
		if(iOdds >> 16) // Odd height
		{
			if(iSects >> 16) // Start-angle > end-angle
			{
				var xl = (yEndA <= cy || yEndZ > cy)? (cx - x) : cx;
				this._mkDiv(xl, cy, x + cx - xl + (iOdds & 0xffff), 1);
			}
			else if((iSects & 0x01) && yEndZ > cy)
				this._mkDiv(cx - x, cy, x, 1);
		}
	};
	this.fillPolygon = function(array_x, array_y) {
		var i;
		var y;
		var miny, maxy;
		var x1, y1;
		var x2, y2;
		var ind1, ind2;
		var ints;

		var n = array_x.length;
		if(!n) return;

		miny = array_y[0];
		maxy = array_y[0];
		for(i = 1; i < n; i++) {
			if(array_y[i] < miny)
				miny = array_y[i];

			if(array_y[i] > maxy)
				maxy = array_y[i];
		}
		for(y = miny; y <= maxy; y++) {
			var polyInts = new Array();
			ints = 0;
			for(i = 0; i < n; i++) {
				if(!i) {
					ind1 = n-1;
					ind2 = 0;
				} else {
					ind1 = i-1;
					ind2 = i;
				}
				y1 = array_y[ind1];
				y2 = array_y[ind2];
				if(y1 < y2) {
					x1 = array_x[ind1];
					x2 = array_x[ind2];
				} else if(y1 > y2) {
					y2 = array_y[ind1];
					y1 = array_y[ind2];
					x2 = array_x[ind1];
					x1 = array_x[ind2];
				} else continue;

				 //  Modified 11. 2. 2004 Walter Zorn
				if((y >= y1) && (y < y2))
					polyInts[ints++] = Math.round((y-y1) * (x2-x1) / (y2-y1) + x1);

				else if((y == maxy) && (y > y1) && (y <= y2))
					polyInts[ints++] = Math.round((y-y1) * (x2-x1) / (y2-y1) + x1);
			}
			polyInts.sort(_CompInt);
			for(i = 0; i < ints; i+=2)
				this._mkDiv(polyInts[i], y, polyInts[i+1]-polyInts[i]+1, 1);
		}
	};

	this.drawString = function(txt, x, y) {
		this.htm += '<div style="position:absolute;white-space:nowrap;'+
			'left:' + x + 'px;'+
			'top:' + y + 'px;'+
			'font-family:' +  this.ftFam + ';'+
			'font-size:' + this.ftSz + ';'+
			'color:' + this.color + ';' + this.ftSty + '">'+
			txt +
			'<\/div>';
	};

	this.drawStringRect = function(txt, x, y, width, halign) {
		this.htm += '<div style="position:absolute;overflow:hidden;'+
			'left:' + x + 'px;'+
			'top:' + y + 'px;'+
			'width:'+width +'px;'+
			'text-align:'+halign+';'+
			'font-family:' +  this.ftFam + ';'+
			'font-size:' + this.ftSz + ';'+
			'color:' + this.color + ';' + this.ftSty + '">'+
			txt +
			'<\/div>';
	};

	this.drawImage = function(imgSrc, x, y, w, h, a) {
		this.htm += '<div style="position:absolute;'+
			'left:' + x + 'px;'+
			'top:' + y + 'px;'+
			// w (width) and h (height) arguments are now optional.
			(w? ('width:' +  w + 'px;') : '') +
			(h? ('height:' + h + 'px;'):'')+'">'+
			'<img src="' + imgSrc +'"'+ (w ? (' width="' + w + '"'):'')+ (h ? (' height="' + h + '"'):'') + (a? (' '+a) : '') + '>'+
			'<\/div>';
	};

	this.clear = function() {
		this.htm = "";
		if(this.cnv) this.cnv.innerHTML = "";
	};

	this._mkOvQds = function(cx, cy, x, y, w, h, wod, hod)
	{
		var xl = cx - x, xr = cx + x + wod - w, yt = cy - y, yb = cy + y + hod - h;
		if(xr > xl+w) {
			this._mkDiv(xr, yt, w, h);
			this._mkDiv(xr, yb, w, h);
		} else
			w = xr - xl + w;
		this._mkDiv(xl, yt, w, h);
		this._mkDiv(xl, yb, w, h);
	};
	
	this._mkArcDiv = function(x, y, oy, cx, cy, iOdds, aBndA, aBndZ, iSects)
	{
		var xrDef = cx + x + (iOdds & 0xffff), y2, h = oy - y, xl, xr, w;

		if(!h) h = 1;
		x = cx - x;

		if(iSects & 0xff0000) // Start-angle > end-angle
		{
			y2 = cy - y - h;
			if(iSects & 0x00ff) {
				if(iSects & 0x02) {
					xl = Math.max(x, aBndZ[y]);
					w = xrDef - xl;
					if(w > 0) this._mkDiv(xl, y2, w, h);
				} if(iSects & 0x01) {
					xr = Math.min(xrDef, aBndA[y]);
					w = xr - x;
					if(w > 0) this._mkDiv(x, y2, w, h);
				}
			} else
				this._mkDiv(x, y2, xrDef - x, h);
			y2 = cy + y + (iOdds >> 16);
			if(iSects & 0xff00) {
				if(iSects & 0x0100) {
					xl = Math.max(x, aBndA[y]);
					w = xrDef - xl;
					if(w > 0) this._mkDiv(xl, y2, w, h);
				} if(iSects & 0x0200) {
					xr = Math.min(xrDef, aBndZ[y]);
					w = xr - x;
					if(w > 0) this._mkDiv(x, y2, w, h);
				}
			} else
				this._mkDiv(x, y2, xrDef - x, h);
		} else {
			if(iSects & 0x00ff) {
				if(iSects & 0x02)
					xl = Math.max(x, aBndZ[y]);
				else
					xl = x;
				if(iSects & 0x01)
					xr = Math.min(xrDef, aBndA[y]);
				else
					xr = xrDef;
				y2 = cy - y - h;
				w = xr - xl;
				if(w > 0) this._mkDiv(xl, y2, w, h);
			}
			if(iSects & 0xff00) {
				if(iSects & 0x0100)
					xl = Math.max(x, aBndA[y]);
				else
					xl = x;
				if(iSects & 0x0200)
					xr = Math.min(xrDef, aBndZ[y]);
				else
					xr = xrDef;
				y2 = cy + y + (iOdds >> 16);
				w = xr - xl;
				if(w > 0) this._mkDiv(xl, y2, w, h);
			}
		}
	};

	this.setStroke(1);
	this.setFont("verdana,geneva,helvetica,sans-serif", "12px", Font.PLAIN);
	this.color = "#000000";
	this.htm = "";
	this.wnd = wnd || window;

	if(!jg_ok) _chkDHTM();
	if(jg_ok) {
		if(cnv) {
			if(typeof(cnv) == "string")
				this.cont = document.all? (this.wnd.document.all[cnv] || null)
					: document.getElementById? (this.wnd.document.getElementById(cnv) || null)
					: null;
			else if(cnv == window.document)
				this.cont = document.getElementsByTagName("body")[0];
			else this.cont = cnv;
			this.cnv = this.wnd.document.createElement("div");
			this.cnv.style.fontSize=0;
			this.cont.appendChild(this.cnv);
			this.paint = jg_dom? _pntCnvDom : _pntCnvIe;
		} else
			this.paint = _pntDoc;
	} else
		this.paint = _pntN;

	this.setPrintable(false);
}
function _mkLinVirt(aLin, x1, y1, x2, y2) {
	var dx = Math.abs(x2-x1), dy = Math.abs(y2-y1),
	x = x1, y = y1,
	xIncr = (x1 > x2)? -1 : 1,
	yIncr = (y1 > y2)? -1 : 1,
	p,
	i = 0;
	if(dx >= dy) {
		var pr = dy<<1,
		pru = pr - (dx<<1);
		p = pr-dx;
		while(dx > 0)
		{--dx;
			if(p > 0)    //  Increment y
			{
				aLin[i++] = x;
				y += yIncr;
				p += pru;
			}
			else p += pr;
			x += xIncr;
		}
	} else {
		var pr = dx<<1,
		pru = pr - (dy<<1);
		p = pr-dy;
		while(dy > 0)
		{--dy;
			y += yIncr;
			aLin[i++] = x;
			if(p > 0)    //  Increment x
			{
				x += xIncr;
				p += pru;
			}
			else p += pr;
		}
	}
	for(var len = aLin.length, i = len-i; i;)
		aLin[len-(i--)] = x;
};
function _CompInt(x, y) {
	return(x - y);
}

